/*
 * This file is part of Bluhell Firewall Browser Extension,
 * Copyright (c) 2015, Diego Casorran. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

'use strict';

var DOMAINS = [
	// Privacy (03 Apr 2015 17:11 UTC)
	/(?:^|\.)(?:0(?:stats|tracker)|1(?:03bees|1nux|2(?:3co(?:mpteur|unt)|mnkys)|-cl0ud|freecounter|pel)|2(?:0(?:0summit|6solutions)|1sme|4(?:7ilabs|counter|log))|3(?:3across|60(?:tag|i)|d(?:live)?stats)|4oney|5(?:1(?:network|yes)|5labs)|7(?:7tracking|bpeople)|99(?:c(?:lick|ounters)|stats)|a(?:013|-counters|\.mobify|a(?:ddzz|n\.amazon)|bc(?:ompteur|stats)|c(?:cessintel|e(?:counter|trk)|s86|t(?:i(?:onallocator|ve(?:-trk7|conversion|meter|prospects|tracker\.activehotels))|nx)|xiom-online)|d(?:buyer|chem(?:ix|y-content|y)|d(?:freestats|lvr)|e(?:lixir|mails)|greed|insight|ku|o(?:betag|ftheyear)|se(?:nsedetective|ttings)|traction|ultblogtoplist|v(?:anced-web-analytics|conversion)|yapper)|ffi(?:liates-pro|n(?:esystems|itymatrix)|stats)|g(?:entinteractive|kn)|i(?:mediagroup|rpr)|kstat|l(?:e(?:nty|xametrics)|kemics|ltracked|tastat|venda|zexa)|m(?:a(?:desa|valet|zingcounters)|bercrow|ikay|xdt)|n(?:a(?:l(?:oganalytics|yt(?:ics(?:-egain|wizard)|k))|metrix|tid3)|dyhoppe|gelfishstats|onymousdmp|tvoice)|p(?:ex(?:stats|two)|ollofind)|qtracker|r(?:cadeweb|kayne|lime|p(?:uonline|xs)|turtrack)|s(?:soctrac|tro-way)|t(?:oshonetwork|raxio|tracta)|u(?:d(?:ience(?:\.visiblemeasures|amplify|iq|rate)|rte)|t(?:horinsights|o(?:-ping|affiliatenetwork)))|v(?:a(?:ntlink|stats)|mws)|w(?:asete|esomelytics))|b(?:a(?:ifendian|ptisttop1000|sicstat)|e(?:acon(?:2\.indieclicktv|\.kmi-us)|bj|e(?:mrdwn|ncounter)|havioralengine|lstat|nchit|sucherzahlen|target)|foleyinteractive|hs4|i(?:gtracker|onicclick|z(?:ible|o))|k(?:rtx|vtrack)|l(?:izzardcheck|o(?:ckmetrics|g(?:104|-stat|counter|meetsbrand|patrol|r(?:ankers|eaderproject)|s(?:counter|ontop)|toplist))|ue(?:cava|kai)|vdstatus)|m(?:23|324|lmedia|metrix)|o(?:omtrain|ts(?:canner|visit)|unce(?:exchange|x))|r(?:cdn|i(?:dgevine|ghtedge|lig)|onto|srvr)|t(?:buckets|static|t(?:rack|tag))|u(?:bblestat|g(?:herd|snag)|rstbeacon|siness\.sharedcount|x1le001)|ytemgdd)|c(?:3(?:metrics|tag)|-o-u-n-t|a(?:dreon|l(?:l(?:ingjustified|measurement|rail)|otag)|mpaigncog|nalstat|phyon-analytics|sh(?:burners|count))|e(?:dexis|lebros-analytics|ntraltag|rtifica|trk)|ftrack|h(?:a(?:nnelintelligence|rt(?:aca|beat))|eezburger-analytics|r(?:ist(?:iantop1000|malicious)|umedia))|ircular-counters|l(?:arity(?:ray|tag)|e(?:a(?:nanalytic|rviewstat)s|v(?:eritics|i))|i(?:ck(?:2meter|-(?:linking|url)|a(?:id|lyz)er|d(?:ensity|imensions)|ening|forensics|inc|m(?:anage|eter)|pathmedia|report|s(?:agen|hif)t|t(?:hru\.lefbc|rack[1s])|zs)|ent\.tahono|x(?:count|py))|oud-exploration|u(?:bcollector|strmaps))|m(?:core|meglobal|ptch)|n(?:etcontentsolutions|xweb|zz)|o(?:2stats|gnitivematch|ll(?:arity|serve)|mp(?:any-target|teur)|n(?:firm(?:ational|it)|t(?:a(?:ctmonkey|dor(?:gratis|web)|toreaccessi)|extly|inue|rol\.cityofcairns)|ver(?:getrack|sion(?:ly|ruler)|t(?:experiments|global|ro)))|oladata|pperegg|r(?:e(?:-cen-54|m(?:etric|otive)s)|mce)|unt(?:by|er(?:-gratis|bot|central|geo|land|s(?:4u|ervis|forlife)|tracker)|his|ing4free|omat|z))|p(?:cmanager|madvisors)|qcounter|r(?:\.loszona|a(?:ftkeys|zyegg)|mmetrixwris|o(?:sswalkmail|wd(?:science|twist))|sspxl)|s(?:bew|data1|i-tracking|s\.aliyun)|t(?:\.(?:itbusinessedge|thegear-box)|nsnet|s(?:-(?:log|secure)\.channelintelligenc|\.(?:businesswir|channelintelligenc))e)|u(?:ntador|stomer(?:conversio|discoverytrack))|xense|y(?:bermonitor|toclause))|d(?:-stats|a(?:counter|ilycaller-alerts|t(?:a(?:\.(?:beyond|imakenews|marketgid)|brain|caciques|feedfile|m)|vantage)|yl(?:ife-analytic|og)s)|c(?:-storm|\.tremormedia)|e(?:17a|cideinteractive|javu\.mlapps|mand(?:base|media\.s3\.amazonaws)|vice9)|gmsearchlab|i(?:d-?it|e-rankliste|ffusion-tracker|gits|mestore|nkstat|rectrdr|s(?:cover-path|playmarketplace|tralytics)|volution)|jers|lrowehtfodne|m(?:analytics1|d53|tr(?:acker|y))|o(?:clix|modomain|ubleverify)|ps-reach|s(?:mmadvantage|p(?:arking|ly))|ti-ranker|u(?:mmy-domain-do-not-change|rocount)|win[12]|yntrk)|e(?:-(?:kaiseki|referrer|zeeinternet)|\.funnymel|a(?:rnitup|sy(?:-hit-counters|counter|hitcounters))|c(?:-track|n5|ommstats(?:\.s3\.amazonaws)?|ustomeropinions)|d(?:ge\.bredg|w\.insideline)|kmpinpoint|l(?:asticbeanstalk|ectusdigital|it(?:e-s001|ics)|oqua)|m(?:a(?:il(?:-(?:match|reflex)|retargeting)|rbox)|ediatrack|ltrk)|n(?:ecto(?:analytics)?|gine(?:212|64)|hance|quisite|sighten|t(?:er-system|icelabs))|p(?:erfectdata|i(?:lot|track)|roof)|reportz|s(?:earchvision|omniture|ta(?:disticasgratis|ra|t))|t(?:ahub|h(?:erealhakai|nio)|r(?:acker|igue)|yper)|u(?:-survey|ro(?:counter|pagerank))|v(?:anetpro|e(?:nt(?:\.loyalty\.bigdoor|tracker\.videostrip)|rgage)|isit(?:analyst|cs2?)|olvemediametrics)|web(?:analytics|counter)|x(?:act(?:ag|target)|clusiveclicks|elator|it(?:intel|monitor)|plore-123|t(?:ole|reme-dm))|zytrack)|f(?:a(?:bricww|ctortg|rmer\.wego|st(?:analytic|ly-analytics|onlineusers|webcounter)|thomseo)|bgdc|e(?:ed(?:ji|perfec)t|tchback)|i(?:litrac|n(?:alid|derlocator)|shhoo|xcounter)|l(?:a(?:gcounter|sh(?:-(?:counter|stat)|adengine|gamestats))|counter|ix(?:360|car|facts)|u(?:ctuo|encymedia|rry)|x(?:pxl|1)|yingpt)|o(?:llowercounter|otprintlive|r(?:eseeresults|m(?:alyzer|isimo))|undry42)|prnt|qtag|r(?:e(?:e(?:-(?:counter|website-(?:hit-counter|statistic)s)|bloghitcounter|counter(?:code|stat)|logs|onlineusers|s(?:itemapgenerator|tats)|usersonline|weblogger)|s(?:coerspica|h(?:counter|plum)))|iendbuy|osmo|uitflan)|shka|u(?:eldeck|n(?:-hits|neld|stage)|sestats)|yreball)|g(?:botvisit|e(?:mtrackers|o(?:bytes|co(?:mpteur|ntatore))|t(?:backstory|clicky|freeb(?:acklinks|l)|response|smartcontent))|igcount|l(?:anceguide|btracker|ob(?:ase|etrackr))|o(?:-stats\.dlinkddns|\.toutapp|dhat|ingup|ldstats|neviral|ogleadservices|pjn|s(?:quared|tats)|urmetads|vmetric)|r(?:a(?:ph(?:effect|insider)|vity)|idsum|oundspeak)|topstats|u-pix\.appspot|visit)|h(?:4k5|a(?:l(?:ldata|stats)|veamint|ymarket)|e(?:a(?:ls\.msgfocu|panalytic)s|llosherpa|ntaicounter|tchi|ystaks)|i(?:conversion|gh(?:erengine|metrics)|perstat|stats|t(?:2map|-(?:count(?:er-download|s)|parade)|box|counters(?:online|tats)|farm|matic|s(?:2u|l(?:ink|og)|niffer|processor)|t(?:ail|racker)|w(?:ake|ebcounter)))|lserve|m\.baidu|o(?:mechader|st-tracker|t(?:-count|jar))|qhrt|u(?:b(?:rus|spot)|manclick|nt-leads|rra)|wpub|xtrack|y(?:fntrak|pe(?:ractivate|stat)))|i(?:-stats|b(?:-ibi|illboard|pxl)|c(?:-live|live|s0)|dtargeting|esnare|factz|ivt|l(?:jmp|lumenix|ogbox)|m(?:a(?:gedoll|nginatium)|manalytics|p(?:\.(?:affiliator|c(?:lickability|onstantcontact))|counter)|rtrack)|n(?:boxtag|d(?:ex(?:stat|tool)s|icia)|eedhits|f(?:erclick|lectionpointmedia)|novateads|p(?:honic|ref(?:\.s3\.amazonaws)?|wrd)|s(?:i(?:de-graph|ght(?:\.mintel|era|grit)|temetrics)|pectlet)|t(?:e(?:l(?:evance|imet|li(?:-(?:direct|tracker)|ad-tracking|gencefocus))|r(?:ceptum|estably|mundomedia|vigil))|rastats)|v(?:itemedia|odo))|p(?:2(?:location|map|phrase)|-a(?:dress|pi)|addresslabs|catch|erceptions|f(?:ingerprint|rom)|infodb|locationtools|ro|stat)|rs09|st(?:-t)?rack|t(?:alianadirectory|rackerpro)|webtrack|xiaa|zea(?:ranks)?)|j(?:anrain|i(?:ankongbao|mdo-stats|rafe)|s(?:counter|onip|tracker)|umptime|wmstats)|k(?:am(?:eleoon|pyle)|ey(?:wordmax|xel)|i(?:eden|ss(?:metrics|testing))|l(?:ert|ldabck)|o(?:mtrack|psil|stenlose-counter)|syrium0014)|l(?:2\.visiblemeasures|a(?:ndingpg|serstat)|ct\.salesforce|e(?:ad(?:-(?:123|converter)|for(?:ce1|ensics|mix)|i(?:um|d)|life|managerfx|sius|zu)|g(?:enhit|olas-media)|s-experts|tterboxtrail|vexis|xity)|i(?:adm|bstat|n(?:ezing|k(?:-smart|\.huffingtonpost|pulse|xchanger))|strakbi|vestat)|loogg|o(?:calytics|g(?:\.kukuplay|aholic|counter|dy|entries|gly|ua)|o(?:kery|p11)|pley|sstrack)|p(?:beta|orirxe)|sfinteractive|uc(?:idel|kyorange)|xtrack|y(?:pn|tiks))|m(?:-pathy|\.addthisedge|a(?:g(?:iq|nify360)|p(?:loco|myuser)|r(?:insm|ket(?:015|2lead)|tianstats)|sterstats|th(?:eranalytics|tag)|xymiser)|b(?:4a|otvisit)|dotlabs|e(?:asuremap|dia(?:armor|bong|forgews|gauge|seeding|v)|ga-stats|latstat|mecounter|rc(?:adoclics|ent)|t(?:alyzer|e(?:orsolutions|ring\.pagesuite)|ri(?:csdirect|go))|zzobit)|i(?:albj6|codigo|das-i|llioncounter|xpanel)|kt(?:3261|941|oresp)|l(?:314|click|etracker|no6|stat)|m(?:i-agency|stat|tro)|o(?:bify|chibot|n(?:goosemetric|iti)s|trixi|use(?:flow|stats|trace)|vable-ink-6710)|plxtms|sg(?:app|tag)|t(?:racking|s\.mansion)|v(?:ilivestats|tracker)|xpnl|y(?:affiliateprogram|bloglog|fastcounter|newcounter|omnistar|r(?:eferer|oitracking)|s(?:coop-tracking\.googlecode|eostats)|tictac|usersonline))|n(?:a(?:ayna|look|tpal|v(?:dmp|egg)|ytev)|e(?:atstats|dstat|on-lab|stedmedia|t(?:-filter|m(?:ini)?ng|ratings)|w(?:relic|scurve|trackmedia)|xtstat)|ga(?:cm|static)|i(?:cewii|ftymaps|nestats)|o(?:nxt1\.c\.youtube|owho|rdicresearch|winteract)|prove|stracking|uconomy|ytlog)|o(?:adz|bserverapp|ctopart-analytics|d(?:\.visiblemeasures|oscope)|ffer(?:matica|s(?:\.keynote|trategy))|hmystats|idah|m(?:e(?:tri|d)a|iki|nitagjs)|n(?:estat|gsono|line-media-stats)|p(?:bandit|en(?:click|hit|venue|xtracker)|roi|t(?:i(?:m(?:ahub|izely(?:\.appspot)?|ost)|n-machine)|orb))|r(?:anges88|capia|g-dot-com|ts\.wixawin)|t(?:oshiana|racking)|urnet-analytics|verstat|wldata|xidy)|p(?:0\.raasnet|-td|\.raasnet|a(?:-oa|ge(?:fair|rankfree)|idstats|r(?:dot|klogic|rable|sely)|ss-1234|thful)|c(?:licks|speedup)|e(?:erius|r(?:centmobile|f(?:ectaudience|iliate|orm(?:ancerevenues|tracking))|ion|s(?:ianstat|onyze))|tametrics)|f\.aclst|h(?:on(?:e-an)?alytics|pstat)|i(?:ano-media|ckzor|kzor|ng(?:-fast|agenow|omatic)|x(?:\.speedbit|analytics|el(?:\.(?:parsely|xmladfeed)|eze|interactivemedia|revenue|s(?:\.youknowbes|nippe)t)|imedia))|jtra|l(?:a(?:cemypixel|tformmunicatorcorp)|e(?:cki|isty|xop))|m14|o(?:intomatic|larmobile|psample|rngraph|st(?:affiliatepro|clickmarketing)|wercount)|r(?:-chart|e(?:cisioncounter|dictivedna)|o(?:clivitysystems|ductsup|ext|file(?:rtracking3|snitch)|j(?:ect(?:haile|sunblock)|op\.dnsalias)|specteye|v(?:enpixel|idence\.voxmedia))|tracker)|s(?:tat|yma-statistic)s|t(?:p123|rk-wn)|u(?:blish(?:\.pizzazzemail|flow)|l(?:leymarketing|se(?:log|maps))|re(?:airhits|video)|tags))|q(?:-counter|bop|dtracking|sstats|u(?:altrics|bitproducts|est(?:ionpro|radeaffiliates)|i(?:llion|ntelligence))|zlog)|r(?:a(?:d(?:ar(?:stats|url)|iomanlibya)|mpmetrics|nk(?:-(?:hits|power)|in(?:gpartner|teractive))|pidcounter)|e(?:a(?:c(?:h(?:force|socket)|tful)|d(?:ertracking|notify)|l(?:counters|t(?:imeplease|racker)))|coset|d(?:ir\.widdit|statcounter)|edge|f(?:er(?:forex|lytics|sion)|inedads)|l(?:ead|iablecounter|maxtop)|marketstats|porting\.reactlite|s(?:-x|ea(?:rch(?:-(?:artisan|tool)|intel)|u-pub)|on8|ponsetap)|v(?:enue(?:pilot|science)|olvermaps)|wardtv|ztrack)|fihub|hinoseo|i(?:astats|ch(?:ard-group|metrics|relevance)|ghtstats|tecounter)|k(?:dms|tu)|lcdn|n(?:engage|g-snp-003|labs)|o(?:i(?:-pro|s(?:ervice|py)|testing|vista)|llingcounters)|rimpl|svpgenius|umanalytics|ztrkr)|s(?:a(?:dv\.dadapro|pha|revtop|yyac)|bdtds|c(?:astnet|hoolyeargo|iencerevenue|o(?:recardresearch|ut\.haymarketmedia)|rip(?:pscontroller|t(?:il|s(?:21|head))))|e(?:arch(?:feed|ignite|plow)|cure(?:-pixel|\.ifbyphone|paths)|dotracker|e(?:hits|why)|gment(?:-analytics)?|l(?:ari|lpoint)s|manticverses|pyra|r(?:ious-partners|v(?:e(?:dbyopenx|stats)|ustats))|ssioncam|x(?:counter|ystat))|h(?:aredcount|i(?:nystat|ppinginsights)|rinktheweb)|i(?:ftscience|g(?:\.gamerdna|nup-way)|lverpop|mple(?:hitcounter|reach)|nglefeed|te(?:apps|bro|compass|improve|linktrack|meter|stat|t(?:istik|racker)))|kyglue|lingpic|m(?:allseotools|fsvc|rtlnks)|n(?:aps\.vidiemi|iphub|o(?:obi|wsignal))|o(?:cketanalytics|doit|krati|metrics|phus3)|p(?:e(?:cialstat|ed-trap)|ider-mich|l(?:ittag|urgi|yt)|n-twr-14|ot(?:ilocal|mx)|ring(?:metrics|serve)|tag[123]?|y(?:log|words))|quidanalytics|t(?:at(?:count(?:er(?:free)?)?|h(?:at|ound)|i(?:c\.parsely|st(?:i(?:c(?:he-(?:free|web)|s\.m0lxcdn\.kukuplay)|q)|x))|owl|s(?:4(?:all|you)|adv\.dadapro|forever|i(?:mg|nsight|t)|machine|rely|sheet|wave)|t(?:ooz|rax)|u(?:ncore|scake|n))|c(?:llctrs|ounter)|eelhousemedia|ippleit|orm(?:containertag|iq))|u(?:b2tech|mome|ndaysky|per(?:counter|stat)s|r(?:f(?:counters|ertracker)|v(?:ey(?:scout|writer)|icate)))|vtrd|w(?:fstats|iss-counter|oopgrid)|xtracking|y(?:nergy-e|somos))|t(?:-analytics|\.(?:d(?:evnet|gm-au)|powerreviews)|a(?:g(?:4arm|commander|ifydiageo)|iltarget|pstream|rgetfuel)|cimg|dstats|e(?:aliumiq|l(?:ize|laparts?)|ndatta|rabytemedia|t(?:igi|oolbox))|he(?:adex|b(?:estlinks|righttag)|counter|freehitcounter|rmstats|specialsearch)|i(?:nycounter|tag)|m(?:pjm|vt)p|o(?:p(?:100(?:blogger|webshop)s|-bloggers|blog(?:area|ging)|depo|malaysia|ofblogs|stat)|rbit|uchclarity)|r(?:a(?:ce(?:-2000|\.qq|lytics|works)|f(?:fikcntr|it)|il(?:-web|headapp)|k(?:ksocial\.googlecode|zor))|e(?:ehousei|ndcounter)|igg(?:er(?:edmessaging|tag\.gorillanation)|it)|k(?:\.pswec|jmp|lnks))|s(?:c(?:apeplay|ounter)|k[45]|w0)|twbs\.channelintelligence|urn|wcount|ynt)|u(?:5e|a(?:dx|rating)|bertags|gdturner|mbel|ni(?:caondemand|versaltrackingcontainer)|p(?:-rank|t(?:imeviewer|racs))|rl(?:brie|sel)f|s(?:abil(?:itytools|la)|er(?:cycle|dive|look|onlinecounter|report|zoom)|uarios-online)|zrating)|v(?:amaker|banalytics|d(?:na-assets|oing)|e(?:duy|interactive|laro|ntivmedia|r(?:t(?:icals(?:cope|earchworks)|ster)|ypopularwebsite))|i(?:deostat|glink|nlens|r(?:alninjas|ool)|s(?:i(?:b(?:ility-stats|l(?:emeasures|i))|oncriticalpanels|stat|t(?:or(?:-track|globe|inspector|js|p(?:ath|rofiler)|tracklog|ville)|streamer))|ual(?:dna(?:-stats)?|revenue|websiteoptimizer))|v(?:istats|ocha)|zu(?:ry)?)|m(?:m(?:-satellite[12]|pxl)|trk)|o(?:icefive|odooalerts|tistics))|w(?:3counter|atch\.teroti|e(?:b(?:-(?:stat|visor)|c(?:are\.byside|ompteur)|flowmetrics|g(?:lstats|ozar)|iqonline|leads-tracker|masterplan|s(?:erviceaward|ite(?:-hit-counters|ceo|perform|sampling|welcome)|pectator|tats4u)|t(?:r(?:a(?:ffiq|xs)|ends)|una))|count4u)|h(?:ackedmedia|itepixel|o(?:aremyfriends|s(?:clickingwho|eesyou|on)))|iki(?:a-beacon|odeliv)|o(?:opra-ns|rldlogger)|p(?:-stats|dstat)|r(?:ating|edint)|statslive|t(?:p101|stats)|undercounter|ww-path|ysistat|zrkt)|x(?:-traceur|a-counter|clk-integracion|g4ken|hit|iti|l-counti|tremline|xxcounter)|y(?:-track|a(?:manoha|udience)|botvisit|ellowbrix|i(?:eld(?:bot|ify|software)|gao)|ouramigo)|z(?:dtag|e(?:bestof|nlivestats|sep)|irve100|o(?:om(?:flow|ino)|wary)|roitracker|t(?:-dst|cadx)))\.com$/,
	/(?:^|\.)(?:2(?:cnt|o7)|3(?:60tag|gl)|8020solutions|a(?:8ww|-pagerank|bmr|c(?:estats|int)|d(?:c(?:-serv|l(?:ear|ickstats))|dcontrol|track\.calls)|gencytradingdesk|mctp|na(?:ly(?:sistools|tics-engine)|metrix)|picit|udienceinsights|vazu(?:dsp|tracking)|xf8|8)|b(?:a(?:rillianc|ynot)e|btrack|etarget|i(?:dswitch|g(?:mir|stats)|zspring)|log(?:ranking|tw))|c(?:edexis|h(?:artbeat|eckmypr)|ityua|lick(?:able|c(?:lick|onversion)|tale)|n(?:t1|zz)|o(?:gmatch|n(?:tentspread|ver(?:sionlogic|tmarketing))|pacast|unter(?:-kostenlos|city|views))|r(?:osspixe|wdcntr)l|ya(?:1t|2))|d(?:1447tq2m68ekg\.cloudfront|21o24qxwf7uku\.cloudfront|3a2okcloueqyx\.cloudfront|9lq0o81skkdj\.cloudfront|e(?:c(?:dna|ibelinsight)|mdex|qwas)|i(?:gidip|scovertrail)|o(?:minocounter|tmetrics)|u8783wkf05yr\.cloudfront)|e(?:-pagerank|d(?:geadx|t02)|ffectivemeasure|resmas|s(?:m1|track)|u(?:lerian(?:cdn)?|ropuls)|v(?:erest(?:js|tech)|yy)|yeota|zakus)|f(?:eedcat|l(?:ixsyndication|owstats)|re(?:e(?:-counters|geoip|stats)|maks)|uziontech)|g(?:\.delivery|eoplugin|o-mpulse|simedia|uanoo)|h(?:it(?:maze)?-counters|s(?:-analytics|cta)|urterkranach)|i(?:bpxl|hstats\.cloudapp|mcht|n(?:centivesnetwork|dividuad|finity-tracking|stadia)|p(?:-label|count(?:er)?)|yi)|jump-time|k(?:eymetric|itcode|nowledgevine|ontagent)|l(?:fov|ivehit|o(?:gnormal|opfuse)|ypn)|m(?:a(?:gnetmail1|rketo|x(?:track|ymis)er)|e(?:dia(?:bong|partner\.bigpoint)|etrics|gastat)|kt51|m7|o(?:balyzer|n(?:etate|itus))|pwe|stracker|x(?:cdn|ptint)|y(?:pagerank|stat-in))|n(?:e(?:dstat(?:basic|pro)?|tgraviton)|gmco|pario-inc|uggad)|o(?:fferpoint|jrq|mtrdc|nline-(?:metrix|right-now)|p(?:en(?:stat|tracker)|tify)|spserver|wneriq)|p(?:\.delivery|ages05|ingdom|m0|pctracking|r(?:edict(?:iveresponse|a)|nx|oxad))|q(?:baka|uick-counter)|r(?:7ls|apidstats|e(?:altimestatistics|dcounter|edbusiness|invigorate|v(?:enuewire|sw))|oi(?:-rocket|tracking)|s6|tfn)|s(?:3s-main|a(?:geanalyst|yyac)|coutanalytics|e(?:arch\.mediatarget|masio|nsic|o(?:-master|parts))|itebro|m(?:art(?:-ip|erremarketer|racker)|ileyhost)|o(?:cialtrack|ftonic-analytics)|p(?:acehits|eedcounter|ring-tns|ycounter)|rpx|tat(?:is(?:fy|ti(?:chegratis|k-gallup))|sadvance-01)|ubmitnet|ynthasite)|t(?:\.ymlp275|cactivity|e(?:lemetrytaxonomy|ntaculos)|hes(?:earchagency|tat)|ns-cs|overy|r(?:a(?:cetracking|fiz)|ekmedia|kme|uehits)|ylere)|uapoisk|v(?:antage-media|ertical-leap|i(?:afoura|sitlog|zisense)|tracker)|w(?:55c|aplog|eb(?:-(?:counter|stat)|tr(?:affstats|ekk(?:-us)?))|hoisonline|t-eu02|underloop)|xclaimwords|y(?:oochoose|wxi)|z(?:dbb|iyu|oosnet|qtk))\.net$/,
	// Advertisement (03 Apr 2015 17:10 UTC)
	/(?:^|\.)(?:0(?:07-gateway|icep80f|llii0g6)|1(?:0(?:0pour|1m3|3092804|pipsaffiliates|y5gehv)|100i|23(?:cursors|vidz)|40proof|5(?:2media|yomodels)|8(?:00freecams|8server|clicks|naked)|clickdownloads|loop|phads|tizer|yk851od)|2(?:0(?:6ads|dollars2surf)|1sexturycash|4(?:7realmedia|x7adservice)|54a|dpt|kurl|leep|xbpub)|3(?:2b4oilo|393|50media|6(?:0(?:ads|yield)|5sbaffiliates)|7signals|cnce854|l(?:ift|r67y45)|omb|r(?:dads|edlightfix)|t7euflv)|4(?:0xbfzk8|3plc|5i73jv6|dsply|uvjosuc|wnet)|5(?:9zs1xei|clickcashsoftware|dimes|gl1x9qc)|6(?:00z|99fy4ne)|7(?:50industries|77(?:-partners?|partner|seo)|cxcrejm|insight|search|u8a8i88|vws1j1j)|8(?:3nsdjqqo1cau183xz|88(?:casino|games|medianetwork|p(?:oker|romos))?|ipztcc1)|9(?:7d73lsi|ts3tpia)|a(?:2pub|3pub|4(?:33|dtrk)|5pub|-static|\.(?:raasnet|sucksex)|a\.voice2page|b(?:letomeet|outads\.quantcast|usedbabysitters)|c(?:c(?:e(?:lacomm|ss-mc)|mgr|ounts\.pkr|userveadsystem)|mexxx|ronym|ti(?:on(?:desk|locker)|vedancer))|d(?:1(?:2[01235789]|3[124])m|2(?:games|up)|4(?:game|partners)|-(?:411|bay|clicks|f(?:eeds|low)|gbn|indicator|maven|s(?:ponso|ti)r|u)|a(?:cado|gora|pd)|b(?:\.fling|lade|ma|oost|r(?:au|ite|oo)|u(?:ddiz|ll|tler(?:-boson)?))|c(?:a(?:de|sh)|d(?:nx|e)|entriconline|h(?:ap|emical)|lick(?:afric|medi)a|olo(?:ny)?|r(?:on|u))|d(?:aim|bags|elive|i(?:nto|ply)|oer|roid|t(?:his|oany)|ynamix)|e(?:cn|dy|lement|ngage|spresso|x(?:cite|prts?|tent))|f(?:a(?:ctory88|rm\.mediaplex)|eedstrk|o(?:otprints|rg(?:ames|einc))|r(?:amesrc|ontiers)|u(?:nkyserver|sion|x))|g(?:a(?:lax|rdener|temedia)|e(?:ar|nt007)|i(?:la|tize)|o(?:rithms|to)|r(?:oups|x))|h(?:ese|itzads|o(?:od|stingsolutions))|i(?:c(?:ate|io)|m(?:ise|p(?:act|eria|s))|n(?:c(?:on|h)|digo|terax)|q(?:global|uity)|reland|s(?:fy|n)|tion)|j(?:al|ector|u(?:ggler|n(?:gle|ky)|g))|k(?:lip|nowledge|onekt|2)|l(?:andpro|egend|isher|o(?:aded|oxtracking)|ux)|m(?:a(?:iltiser|mba|nage|rvel|xim)|e(?:ld|ta|z)|itad|ngronline|ob|pads|ulti|zn)|n(?:e(?:ctar|t(?:workm|xchang)e|t)|gin|imation|oble|xs1?)|o(?:bedtm|n(?:ion|ly)|p(?:erator|tim)|rika|t(?:ic|omy|ube))|p(?:a(?:cks|rlor|y)|er(?:fect|iu[mn])|hreak|inion|lxmd|pv|r(?:emo|o(?:fit2share|tected|n)))|quest3d|r(?:e(?:ady(?:tractions)?|sellers|volver)|o(?:cket|ll))|s(?:2srv|4cheap|-stats|a(?:feprotected|lvo|me)|b(?:ookie|rook)|c(?:endmedia|lickingnetwork)|dk|ensecamp|f(?:ast|orindians|u(?:ndi|se))|gangsta|h(?:ack|exa|o(?:pping|st(?:net|view|[12]))|uffle)|i(?:gnal|mili|nimage)s|l(?:i(?:dango|ngers)|ot)|m(?:arket|oon)|native|o(?:nar|px|vo)|p(?:dbl|eed|ruce|ynet)|r(?:ing|v(?:\.(?:bangbros|eacdn)|media))|u(?:p(?:ermarket|ply)|rve)|vert|wizz|xgm|ymptotic)|t(?:aily|dp|e(?:c(?:hus|c)|ractive)|gs|lgc|o(?:add|l(?:ogy[123]|l)|ma(?:fusion)?|o(?:ls(?:2\.ama|\.gossip)kings|x))|pix|r(?:gt|ix|overt|uism)|wirl)|u(?:acni|lt(?:3dcomics|-(?:adv|profit-files)|a(?:ccessnow|d(?:media|world))|linkexchange|m(?:ediabuying|o(?:da|viegroup))|popunders|sense|t(?:ds|iz))|rr)|v(?:777|-plus|a(?:n(?:seads|tage(?:globalmarketing|media))|rd)|e(?:ntor[iy]|rsal(?:display|servers)?)|google|m(?:ania|edialtd|d)|points|r(?:edir|tice))|w(?:hirl|ires|or(?:dsservicapi|kmedia|ldmedia))|x(?:core|i(?:on|te)|market|p(?:ansion|o(?:se|wer))|regie)|yo(?:ulike|z)|z(?:hub|mob|o[nu]k|s))|eesy|f(?:cyhf|dads|f(?:-jp\.(?:dxlive|exshot)|b(?:ot[1378]|uzzads)|i(?:liat(?:e-(?:gate|robot|b)|ion-(?:france|int))|nit(?:ad|y))|p(?:lanet|ortal-lb\.bevomedia)|track|utdmedia)|lrm|ricawin|terdownloads?)|g(?:cdn|entcenters|gregateknowledge|mtrk|vzvwof)|halogy|i(?:m(?:4media|atch)|pmedia|rpush)|k1?\.imgaft|l(?:chemysocial|fynetwork|imama|l(?:-about-tech|a(?:bc|dultcash|nalpass)|eliteads|mt|o(?:sponsor|ydigital)|pass\.salemwebnetwork|slotscasino|yes)|p(?:ha(?:bird(?:network)?|godaddy)|inedrct)|t(?:ernativeadverts|itude-arena))|m(?:-display|a(?:teur(?:\.amarotic|match)|zon(?:-cornerstone|ily))|ertazy|gdgt|obee|pxchange|tracking01)|n(?:astasia(?:-international|saffiliate)|domedia(?:group)?|ge(?:ge|lpastel)|ime\.jlist|nualinternetsurvey|o(?:miely|nymousads)|swered-questions|t(?:araimedia|oball)|wufkjjja|yxp)|o(?:qneyvmaz|r(?:ms|pum))|p(?:i\.(?:140proof|f(?:acebook|lattr)|groupon|oneall|starsmp)|mebf|p(?:ads|endad|l(?:ebarq|ifier)|tap)|r(?:il29-disp-download|omoweb)|smediaagency|xlv)|r(?:\.voicefive|ab4eg|cade(?:be|chain)|easnap|ti-mediagroup)|s(?:5000|\.devbridge|afesite|eadnet|hleymadison|iafriendfinder|klots|ooda|rety|s(?:etize|oc-amazon)|terpix)|t(?:emda|malinks|r(?:esadvertising|insic)|wola)|u(?:2m8|ctionnudge|di(?:ence(?:2media|fuel|profiler)|tude)|grenso|nmdhxrco|spipe|to(?:-i(?:nsurance-quotes-compare|m)|linkmaker\.itunes\.apple|mateyourlist))|v(?:alanchers|ercarto|gthreatlabs)|w(?:adhtimes|empire|in1|ltovhc|mpartners|s(?:clic|mer|urveys))|x(?:47mp-xp-21|ill)|z(?:ads|erbazer|jmp|o(?:ogleads|rbe)|tecash))|b(?:2c-wsinsight\.crowdfactory|\.sell|a(?:b(?:bnrs|es\.picrush)|ck(?:beatmedia|links)|d(?:ge(?:\.(?:clevergirlscollective|facebook)|s\.(?:alltop|instagram)|ville)|jocks)|n(?:anaflippy|man\.isoftmarketing)|ordrid|ronsoffers|skodenta|ungarnr|ypops)|b(?:element|p\.brazzer)s|c(?:\.coupons|ash4you)|e(?:a(?:conad|tchucknorri)s|coquin|forescence|l(?:amicash|ointeractive)|ntdownload|ringmedia|st(?:casinopartner|f(?:indsite|orexpartners)|gameads|h(?:itsnow|olly)|o(?:fferdirect|nlinecoupons)|producttesters|ssn)|t(?:3(?:000partner|65affiliate)s|a(?:\.down2crazy|ffs)|rad|ting(?:\.betfair|partners)|weendigital))|fast|gmtracker|i(?:d(?:gewatr|system|vertiser)|emedia|g(?:door|fineads)|jscode|mlocal|n(?:aryoptions(?:24h|game)|go4affiliates|layer)|t(?:coinadvertiser|tad)s|z(?:ographics|rotator|zclick))|l(?:a(?:m(?:ads|city)|rdenso|zwuatr)|inkadr|o(?:cks\.ginotrack|g(?:c(?:atalog|lans)|engage|ger(?:ex|greetbox\.googlecode)|herads|lines|ohertz|topsites)|ssoms)|ue(?:advertise|streak))|manpn|n(?:etworx|mla)|o(?:-videos\.s3\.amazonaws|ard-books|gads|inkcash|n(?:gacams|usfapturbo|zuna)|o(?:-box|k(?:ingdragon|ofsex)|stclic)|roras|ylesportsreklame)|ptracking|r(?:\.rk|a(?:inient|n(?:chr|d(?:-display|clik|reachsys)|zas)|venetmedianetwork)|ea(?:dpro|ltime)|i(?:dgetrack|ght(?:eroption|info|share))|o(?:adstreetads|kersweb|thersincash)|qvld0p|ucelead)|s(?:rv\.adohana|trtb)|t(?:n(?:\.createsend1|ibbler)|rll|tbgroup)|u(?:520|durl|m(?:blecash|pin)|n(?:chofads|ny-net)|r(?:jam|stnet)|sinessc(?:are|lick)|ttons\.(?:contactme|reddit)|xflow|y(?:flood|orselltnhomes|sellads)|zz(?:-stats|buttons|paradise))|winpartypartners|yspot|zrvwbsh5o)|c(?:-on-text|a(?:che\.imagehost123|m(?:4flat|crush|d(?:ough|uty)|p(?:a(?:nja|rtner)|rime)|s(?:\.spacash|ense|itecash)|zap)|no(?:eklix|nresourcecenter)|p(?:acitygrid|itatmarket|t(?:ainad|ifymedia))|r(?:bonads|eers\.adicio|s\.fyidriving|to(?:ontube|rkins))|s(?:alemedia|h(?:4m(?:embers|ovie)|-(?:duck|program)|\.femjoy|atgsc|layer|mylinks|onvisit|t(?:hat|raf(?:ic|f)))|i(?:no(?:\.betsson)?|ours)|pion|t(?:erpretic|platform))|ygh)|b(?:-content|aazars|click(?:bank|s)|leads)|c-dt|dn(?:-image|\.(?:assets\.gorillanation|mobicow|o(?:ffclou|ptm)d)|a(?:\.tremormedia|ds)|jke|rl|servr)|e(?:epq|l(?:ebjihad|ogera)|nnter|r(?:otop|tified-apps))|h(?:a(?:ngo|rltonmedia|tischat)|e(?:-ka|ck(?:m8|outfree)|rytso|styry)|i(?:na-netwave|pleader|tika)|o(?:ices\.truste|pstick16)|ronicads|ualangry)|i(?:bleclick|tysex)|l(?:a(?:sh-media|xonmedia|yaim)|e(?:a(?:fs|r(?:-request|ac))|nte|vv)|i(?:ck(?:2jump|a(?:ble|gy)|b(?:et88|ooth(?:lnk)?)|c(?:ash|ertain)|exa|fuse|ganic|intext|mngr|nano|osmedia|s(?:2count|or|venue)|t(?:hru(?:cash|server)|ripz)|upto|winks|xchange|z\.lonelycheatingwives)|x(?:galore|sense|trac))|oudtracked|ub777)|m(?:dfnow|fads)|o(?:advertise|de(?:\.popup2m|lnet|zap)|edmediagroup|g(?:sdigital|uan)|l(?:dhardcash|l(?:ection-day|iersads)|oredguitar|pory)|m(?:click|m(?:ission(?:-junction|lounge|monster)|unicatoremail)|ple(?:tecarrd|xmedianetwork)|score|unicazio)|n(?:mio|n(?:atix|e(?:ctionads|x(?:place|tra)))|s(?:ent(?:-st)?\.truste|trument|umergenepool)|t(?:a(?:dd|xe)|e(?:nt(?:-cooperation|\.liveuniverse|abc|ure)|xt(?:uads|web)))|ver(?:sionsbox|tsocial))|o(?:kie(?:-script|assistant|consent\.silktide|reports|q)|l(?:erads|mirage))|pacet|rnflip|u(?:ll|pon2buy))|p(?:\.intl\.match|a(?:beyond|c(?:lick[sz]|oreg)|grip|l(?:ead|ock)|nuk|way|ys)|cadnet|fclassifieds|layer\.blinkx|m(?:affiliation|leader|star|t(?:erra|ree))|u(?:im|laptop)|v(?:ad(?:vertise|s)|tgt)|x(?:24|adroit|interactive))|r(?:a(?:k(?:cash|media)|zy(?:lead|videosempire))|e(?:ative-serving|oads)|i(?:spads|teo)|o(?:coads|ssrider|wd(?:g(?:atheradnetwork|ravity)|ynews))|tracklink|uiseworldinc)|s\.(?:celebbusters|exposedontape)|t(?:asnet|cautobody|m-media|rhub)|u(?:bics|elinks|r(?:ancience|iyo|tisfrierson))|wgads|y(?:b(?:er(?:bidhos|netentertainmen)t|mas)|gnus))|d(?:03x2011|2(?:9gqcij|ship)|3lens|-l-t|a(?:ffaite|llavel|n(?:a123|zabucks)|r(?:edorm|warvid)|t(?:e(?:f(?:ree|unclub)|traders)|ing(?:-adv|a(?:dnetwork|mateurs)|factory|gold|idol)))|b(?:bsrv|clix|lpmp)|dfcash|e(?:al(?:current|s(?:\.macupdate|warm))|cision(?:mark|news)|dicated(?:media|networks)|e(?:cash|pmetrix)|faultimg|guiste|livery(?:4[579]|51|\.adyea)|manier|notyro|p(?:loyad|ositphoto|ravedwhore)s|rlatas|stinationurl|troposal|velopermedia|xplatform)|gma(?:tix|ustralia|xinteractive)|hundora|i(?:amondtraff|g(?:i(?:pathmedia|t(?:aldesir|revenu)e)|sby)|nclinx|rect(?:aclick|ion-x|leads|nicparking|orym|rev|track)|s(?:creetlocalgirls|pop|tant(?:news|stat))|v(?:ascam|ertura))|l-rms|m(?:g-mobile|u20vut)|ntrck|o(?:jerena|llar(?:ade|sponsor)|m(?:ain(?:advertising|buyingservices|sponsor)|dex)|ogleonduty|renga|t(?:andad|net(?:kicks|shoutout)|omi)|uble(?:-check|click|gear|pimp|r(?:ads|ecall))|wn(?:1oads|loadthesefile|songlyrics))|p(?:msrv|s(?:rexor|tack))|r(?:eamaquarium|owle)|s(?:n(?:extgen|r-affiliates)|ultra)|t(?:iserv2|mpub|zads)|u(?:delsa|etads|r(?:nowar|tz))|vdkinoteatr|y(?:ino|nami(?:c(?:oxygen|serving)|tedata)))|e(?:9mlrvy1|-(?:generator|viral)|asy(?:ad|download(?:4you|now)|flirt|hits4u|inline)|b(?:ayobjects|dr2|lastengine|uzzing|zkswbs78)|dgevertise|gamingonline|kmas|l(?:e(?:ctnext|fantsearch|kted|pheny)|itsearch)|m(?:berads|ediawebs|jcd|p(?:iremoney|tyspaceads))|n(?:gineseeker|lnks|t(?:erads|recard(?:\.s3\.amazonaws)?))|p(?:icgameads|t(?:ord|um))|r(?:endri|o(?:sadv|tikdating|v(?:ation|inmo))|shgrst)|s(?:c(?:alatenetwork|ortso)|pecifican|say(?:ad|coupon)s)|t(?:argetnet|gdta|o(?:logy|ro)|rader\.kalahari)|u(?:2xml|r(?:ew|o(?:-rx|click|pacas(?:ino|h))))|v(?:ernote|olvenation)|webse|x(?:actdrive|c(?:ellenceads|hange4media|iliburn|lusivepussy|olobar)|ernala|gfpunished|it(?:explos|junct)ion|o(?:clickz?|gripper)|p(?:lorer\.sheknows|onential)|t(?:onsuan|ra33))|ye(?:medias|re(?:turn)?|viewads|wonder)|zmob)|f(?:-(?:hookups|questionnaire)|a(?:ce(?:book(?:cover|ofse)x|porn)|iradsnetwork|nsign\.streamray|st2earn|tads\.toldya)|b(?:-plus|ooksluts|svu)|cgadgets\.blogspot|e(?:ature(?:dusers|link)|ed(?:\.mikle|age|blitz|s\.(?:delicious|videosz))|l(?:ixflow|jack)|m-inc|nixm)|hserve|i(?:gshare|l(?:amentapp(?:-assets)?\.s3\.amazonaws|e(?:loadr|stube|target)|t(?:ermomosearch|hads))|mserve(?:\.myspace)?|nd(?:-abc|andtry|onlinesurveysforcash|sthat)|r(?:axtech|e(?:feeder|gob)|mharborlinked|st(?:-rate|adsolution|class-download|l(?:ightera|oad)|mediahub))|xionmedia)|l(?:ash(?:adtools|clicks|group|talking)|esh(?:cash|lightgirls)|irt(?:4(?:fre)?e|ingsms)|odonas|u(?:idsurvey|xad)s|ymyads)|m(?:dwbsfxf0|s(?:ads|cash))|ncash|o(?:aks|calex|llo(?:wistic|yu)|o(?:dieblogroll|nad|t(?:ar|erslideupad|note))|r(?:ex(?:-affiliate|yard)|getstore|ifiha|pyke|restersurveys)|ulsomty)|r(?:ameptp|e(?:akads|e(?:-porn-vidz|biesurveys|couponbiz|lancer|onescams|paidsurveyz|rotator|skreen|tellafriend|webcams)|st(?:acero|ime))|iendlyduck|u(?:itkings|trun)|x(?:le|rydv))|tjcfx|u(?:andarst|ck(?:bookdating|ermedia|youcash)|elbuck|gger\.ipage|n(?:klick|nypickuplinesforgirl)s|ture(?:residual|u)s)|wix|x(?:depo|yc0dwa))|g(?:4whisperermedia|6ni40i7|726n8cy|a(?:g(?:acon|enez)|inmoneyfast|l(?:ileofive|leyn)|m(?:bling-affiliation|e(?:-clicks|ads|cetera|hotus|rsad|srevenue))|n(?:ardineroreal|ja|nett\.gcion)|r(?:risto|vmedia)|t(?:e-ru|ikus)|y(?:ad(?:network|pros)|xperience))|e(?:fhasio|mineering|n(?:e(?:ric(?:link|steps)|sismedia)|ialradio|ovesetacet)|o(?:\.(?:camazon|query\.yahoo)|i(?:nventory|pads)|promos|riot|visite)|stionpub|t(?:\.(?:2leep|box24casino|davincisgold|paradise8|rubyroyal|slotocash|thisisvegas)|drip|g(?:lu|scfre)e|iton|mailcounter|s(?:corecash|ecuredfiles|mily)))|f(?:hdkse|revenge|xa\.sheetmusicplus)|g(?:ncpm|wcash)|i(?:antaffiliates|gya|miclub|thubbadge\.appspot)|klmedia|l(?:-cash|btrk|ical|o(?:bal(?:adsales|interactive|s(?:ign|uccessclub))|wdot))|o(?:2euroshop|ember|goplexer|joingscnow|lderotica|ogle(?:adservicepixel|syndicatiion)|rgonkil|toplaymillion|v(?:er(?:eign|nmenttrainingexchange)|iral-content))|p(?:acalculatorhighschoolfree|lusapi\.appspot)|r(?:a(?:bmyads|fpedia|tisnetwork|zeit)|e(?:at(?:branddeals|cpm)|enlabelppc|nstia|tzalz|ystripe)|idlockparadise|llopa|o(?:ovinads|upcommerce))|s(?:csystemwithdarren|niper2)|tsads|u(?:itaralliance|mgum|n(?:partners|zblazingpromo)|rurevenue)|wallet|x101)|h(?:12-media|a(?:l(?:fpriceozarks|ogennetwork)|naprop|r(?:dcoresexnow|renmedianetwork)|v(?:etohave|nr))|b-247|d(?:-plugin|player-download|vid-?codecs)|e(?:a(?:dup|lth(?:affiliatesnetwork|carestars|grades))|biichigo|llo(?:bar|reverb)|ntaibiz|rezera|xagram)|i(?:adone|ddenbucks|gh(?:cpm|net)s|jacksystem|mediad[sx]|p(?:als|lair)|t-now|zlireklam)|n(?:-button\.herokuapp|button\.appspot|like)|o(?:kaybo|me-soon|okupbucks|p(?:feed|ilos)|r(?:ny(?:birds|girlsexposed|matches|spots)|sered|yzon-media)|sti(?:canaffiliate|ng\.conduit)|t(?:-(?:dance|social)s|chatdirect|elscombined|keys|ptp|social[sz]|words))|qfootyad4\.blogspot|s(?:mclic|tpnetwor)k|ttpool|yper(?:linksecure|trackeraff|vre|webads))|i(?:2casting|\.skimresources|a(?:mediaserve|sbetaffiliates)|b(?:atom|ryte)|c(?:direct|qadvnew)|d(?:e(?:al(?:-sexe|media)|ntads)|o(?:lbucks|wnloadgalore))|frame(?:\.(?:adultfriendfinder|mediaplazza)|s\.hustler)|g(?:ameunion|loohq|n(?:itioninstaller|up))|heartbucks|iasdomk1m9812m4z3|l(?:api\.ebay|ividnewtab|ovecheating)|m(?:a(?:ge(?:\.(?:cecash|nsk-sys)|s(?:\.(?:d(?:mca|reamhost)|mylot|scanalert)|nake))|sdk\.googleapis)|edia(?:audiences|revenue)|g(?:\.(?:bluehost|hostmonster|mybet|promoddl)|carry|feedget|lt|webfeed)|iclk|p(?:actradius|lix|res(?:ionesweb|sion(?:affiliate|desk))))|n(?:-appadvertising|binaryoption|c(?:entaclick|omeliberation|rease-marketing)|d(?:exww|i(?:a(?:ds|n(?:friendfinder|linkexchange|weeklynews))|eclick)|ofad|ustrybrains)|e(?:ntasky|tinteractive)|f(?:ectiousmedia|inityads|luads|o(?:links|rmation-sale))|it\.lingospot|ktad|line\.playbryte|mobi|n(?:ity|ovid)|s(?:i(?:ghtexpress(?:ai)?|te(?:promotion|systems))|kin(?:ad|media)|t(?:a(?:gramfollowbutton|nt(?:dollarz|paydaynetwork))|i(?:cator|nctiveads|vate)))|t(?:e(?:gral-marketing|lli(?:chatadul|tx)t|nthq|r(?:click|netadbrokers|polls|stitial\.glsp\.netdna-cdn)|xt(?:direc|scrip)t)|opicmedia|rapromotion|trax|uneads)|uvo|v(?:estingchannel|i(?:te\.linescale|ziads)))|pr(?:edictiv|omot)e|s(?:ohits|parkmedia)|t(?:mcash|r(?:engia|xx)|slive)|u(?:16wmye|benda)|vitrine\.buscape|winnersadvantage|x(?:np|spublic)|zeads)|j(?:a(?:dcenter|ngo(?:network)?|smin|vbucks|ymancash)|brlsr|d(?:oqocy|rm4|tracker)|e(?:etyetmedia|mmgroup|rrcotch|ysearch)|fresi|i(?:athis|sbar|wire|zzontoy)|mp9|o(?:7cofh3|b(?:amatic|s(?:\.thejobnetwork|yndicate)|t(?:arget|hread))|in(?:\.filthydatez|bot|nowinstantly)|wapt|y(?:ourself|tocash))|s(?:count|feedadsget|retra)|trakk|u(?:dicated|gglu|ic(?:eadv|yads)|j(?:uads|zh9va)|m(?:boaffiliates|p(?:elead|tap))|nbi-tracker|rsp|s(?:tre(?:levant|sa)|ukrs))|waavsze|yvtidkx|z9ugaqb)|k(?:0z09okc|a(?:looga|n(?:oodle|tarmedia)|play|rgo)|e(?:ewurd|halim|too|ywordblocks)|i(?:kuzip|n(?:ley|tokup)|os(?:how|ked)|tnmedia)|l(?:i(?:k(?:advertising|saya|vip)|pmart|xfeed)|oapers)|nowd|o(?:l(?:estence|it(?:at|ion))|moona|ntextua|ocash)|qzyfj|r(?:3vinsx|aken\.giantrealm)|u(?:ad\.kusogi|mpulblogger))|l(?:a(?:kequincy|nistaconcepts|pi\.ebay|rgestable|serhairremovalstore|unchbit|vantat|yer(?:loop|s\.spacash|welt))|bm1|cl2adserver|dgateway|e(?:ad(?:acceptor|cola|mediapartners)|che69|etmedia|gendarylars|s(?:sbuttons|uard)|tsgetsocialnow)|fstmedia|gse|i(?:ckbylick|ftdna|gat(?:ional|us)|jit|ke(?:btn|control)|nk(?:buddies|c(?:licks|onnector)|e(?:levator|xchange)|grand|mads|referral|s(?:\.freeones|alpha|howoff|mart|ynergy)|w(?:ithin|orth)|ybank)|stingcafe|ve(?:adoptimizer|c(?:am|hatflirt)|intent|jasmin|pr(?:ivate|omotool)s|rail|sexasian|traf|universenetwork)|zads)|mebxwbsno|nkgt|o(?:ading-(?:delivery1|resource)|c(?:al(?:adbuy|edgemedia)|k(?:erdome|hosts))|ginradius|ltrk|o(?:dyas|k(?:it-quick|smart)|ney(?:ads|network))|s(?:omy|tun)|tteryaffiliates|ve(?:adverts|claw|me|rcash)|xtk)|p\.(?:ncdownload|titanpok)er|qcdn|sawards|u(?:cid(?:commerce|media)|minate|shcrush|vc(?:ash|om)|xadv)|x2rv|zjl)|m(?:2pub|4pub|57ku6sm|a(?:d(?:-adz|adsmedia|isonlogic|s(?:erving|one))|g(?:ical-sky|netisemedia)|i(?:l\.advantagebusinessmedia|n(?:adv|roll))|ll(?:com|orcash|sponsor)|n(?:fys|goforex)|p\.pop6|r(?:feel|k(?:\.reevoo|e(?:rly|t(?:banker|health|ing(?:enhanced|solutions\.yahoo)|leverage|network|oring))|swebcams)|sads|tiniadnetwork)|s(?:srelevance|ter(?:nal|wanker))|t(?:iro|rix-cash)|udau|x(?:cash|iadv|serving))|b(?:01|10[234]|38|57|\.marathonbet)|c-nudes|d(?:ialog|lsrv|n2015x1)|e(?:adigital|ccahoo|d(?:als\.bizrate|i(?:a(?:303|6degrees|970|-(?:app|general|toolbar)|\.(?:eurolive|m(?:atch|yko(?:cam|dial))|pussycash)|c(?:lick|pm)|f(?:filiation|lire|orge)|g(?:r(?:idwork|a)|4)|keywords|p(?:ass|eo|lex)|t(?:arget|raks))|umpimpin)|leyads)|e(?:bo|ndocash|t(?:goodgirl|ic-partner)s)|g(?:acpm|base)|in(?:eserver|list)|me\.smhlmao|n(?:epe|t(?:ad|eret))|r(?:aad2\.blogspot|c(?:henta|uras))|ssagespaceads|t(?:a(?:4-group|ffiliation|rtmoney(?:\.met-art)?|verti(?:sing|zer))|hodcash|odoroleta24h)|ubonus|viodisplayads|ya41w7|zimedia)|feed\.newzfind|g(?:cash(?:gate)?|id|platform)|i(?:bebu|croadinc|l(?:abra|l(?:ennialmedia|ionairesurveys))|rago|va|xpo)|k(?:hoj|t(?:mobi|seek))|lnadvertising|m(?:a(?:axx|dsgadget)|gads|ismm|ondi|webhandler\.888)|o(?:8mwxi1|atads|b(?:a(?:lives|tor[iy])|bobr|day|gold|i(?:co(?:nt|w)|fobi|kano|le(?:metrics\.appspot|r(?:affles|evenu))|right|sla|yield)|orobot|strks|trks|ytrks)|delegating|ffsets|gointeractive|j(?:iva|oaffiliates)|konocdn|n(?:dominishows|ey(?:4ads|co(?:ntrol|smos)|tec|whisper)|soonads)|o(?:kie1|termedia|xar)|pilod|re(?:gamers|hitserver|playerz|share)|selats)|p(?:3(?:ix|vicio)|mcash|nrs|rezchc)|rskincash|s(?:\.wsex|quaredproductions)|t(?:\.sellingrealestatemalta|o(?:\.mediatakeout|or)|r(?:css|ee))|u(?:jap|ltiadserv|nically|si(?:c-desktop|k-a-z)|tary)|xtads|y(?:-best-jobs|affiliates|clickbankads|d(?:irtyhobby|reamads)|infotopia|linkbox|precisionads|s(?:earch-online|upercheap)|things|vads)|z28ismn)|n(?:388hkxg|9nedegrees|a(?:bbr|grande|nigans|stydollars|t(?:oms|ure-friend)|ughtyplayful)|b(?:jmp|static)|crjsserver|e(?:blotech|golist|o(?:bux|datagroup|ffic)|t(?:3media|-ad-vantage|avenir|liker|pondads|s(?:eer|olads)|work(?:edblogs|ice|xi))|u(?:desicmediagroup|esdate)|w(?:a(?:ds\.bangbros|gerevenue)|ideasdaily|nudecash|s(?:-whistleout\.s3\.amazonaws|adstream|exbook|gator|memory|togram|whip))|x(?:a(?:ge|c)|tmobilecash))|gecity|i(?:c(?:eratios|head(?:generator|s))|kkiscash)|jmaq|k(?:k31jjp|redir)|o(?:b(?:leppc|setfinvestor)|r(?:etia|mkela|thmay)|vadune|wspots)|pvos|quchhfyex|r(?:elate|nma)|s(?:c(?:ash|ontext)|dsvc|fwads|g\.symantec|martad|pmotion)|t(?:ent|urveev)|u(?:m(?:berium|mobile)|seek|vidp)|v(?:adn|p2auf5)|wfhalifax|xtck|y(?:admcncserve-05y06a|mphdate)|zphoenix)|o(?:2live|ainternetservices|b(?:e(?:sw|us)|jects(?:\.tremormedia|ervers))|c(?:eanwebcraft|l(?:asrv|sasrv|us))|d(?:b\.outbrain|zb5nkp)|ehposan|ffer(?:forge|palads|s(?:-service\.cbsinteractive|erve|quared|syndication\.appspot))|ggifinogi|hmcasting|m(?:click|g(?:pm|uk|2))|n(?:ads|e(?:dmp|networkdirect|spot)|hercam|line(?:-adnetwork|\.mydirtyhobby|ca(?:reerpackage|shmethod))|rampadvertising|scroll|toplist|vertise)|o(?:dode|ecyaauiz|fte|s4l)|p(?:e(?:n(?:adserving|downloadmanager|etray|x(?:adexchang|enterpris)e|x)|ratical)|inionbar|t(?:-intelligence|eama|i(?:matic|nemailpro)))|r(?:arala|bengine|dermc)|spreymedialp|t(?:her(?:profit|sonline)|vetus)|u(?:runlimitedleads|t(?:ils\.f5biz|ster))|ve(?:ld|rtur[es])|x(?:ado|sng|tracking)|z(?:e(?:lmedikal|rtesa)|onemedia))|p(?:2ads|-(?:advg|comme-performance|digital-server)|a(?:ds(?:del(?:ivery)?|tm)|ge(?:rage|sinxt)|idsearchexperts|kranks|n(?:\.dogster|achetech|therads)|perg|r(?:kingpremium|t(?:ner(?:\.(?:alloy|e-conomic|googleadservices|popmog|video\.syndication\.msn)|cash|earning|s\.(?:betus|yobt))|y(?:casino|p(?:artners|oker))))|ssionfruitads|utaspr|y(?:dotcom|gear|perpost))|cash\.(?:globalmailer5|imlive)|dfcomplete|e(?:2k2dty|akclick|cash|e(?:lawaymaker|mee)|numa|p(?:ipo|perjamnetwork)|r(?:cularity|f(?:creatives|ectmarket|ormanc(?:e-based|ingads)|b)|mutive)|xu|zrphjl)|g(?:mediaserve|partner|ssl)|h(?:armcash|eedo|il(?:bard|osophe)re|onespybubble)|i(?:anobuyerdeals|c(?:admedia|bucks|sti|tureturn)|n(?:ballpublishernetwork|ddeals|khoneypots)|p(?:aoffers|pity)|vot(?:almedialabs|runner)|x(?:azza|eltrack66|xur))|jatr|l(?:a(?:ntaosexy|t(?:form\.(?:foursquare|linkedin|tumblr)|inumadvertisement)|xo)|e(?:eko|nomedia)|ista|lddc|ocap|u(?:g(?:err|rush)|sone\.google)|xserve)|m(?:\.web|srvr)|n(?:ads|oss|tr(?:ac|[as]))|o(?:d\.(?:manplay|xpress)|int(?:clicktrack|roll|s2shop)|kerstrategy|l(?:awrg|imantu|luxnetwork|montventures|ydarth)|onproscash|p(?:6\.adultfriendfinder|ander|cp[mv]|earn|m(?:arker|og|yads?)|onclick|s(?:\.freeze|ads)|u(?:l(?:aritish|is(?:engage)?)|nderz|pvia))|r(?:kolt|n(?:-(?:hitz|site-builder)|attitude|conversions|deals|earn|kings|leep|oow|prosnetwork|track)|table-basketball)|st(?:ernel|release)|td\.onlytease|urmajeurs|wer(?:job|link)s)|pc(?:-direct|indo|linking|trck|webspy)|r(?:e(?:cisionclick|dictad|ferences\.truste|miumhdv|s(?:sly|tadsng)|xista)|i(?:c(?:edinfo|kac)|maryads|sacom|va(?:cy(?:-policy\.truste|protector)|te(?:webseiten|4)))|o(?:adsdirect|d\.untd|f(?:figurufast|i(?:le\.bharatmatrimony|tpeelers))|gram3|jectwonderful|mo(?:4partners|\.(?:blackcrush|cams|galabingo|mydirtyhobby|pegcweb|ulust|vador)|benef|cionesweb|s(?:\.(?:gpniches|meetlocals|wealthymen)|hq\.wildfireapp)|tion(?:-campaigns|\.monster|s\.newegg)|webstar)|pel(?:ler(?:ad|pop)|plu)s|sperent|tect-x|wlerz|ximic)|pops|scripts)|s(?:clicks|eqcs05)|t(?:classic|mzr|p2[24]|rfc|webcams)|u(?:b(?:-fit|\.(?:aujourdhui|dreamboxcart)|directe|exchange|gears|li(?:ci(?:dee|tyclerk)s|sh(?:er(?:\.monster|adnetwork)|4))|ted)|lse(?:360|mgr)|nchtab|s(?:h2check|syeatingclub(?:cams)?)|tanapartners)|yiel2bz|zaasocba)|q(?:1(?:media(?:hydraplatform)?|xyxm89)|3sift|adservice|dmil|e(?:ryz|wa33a)|nsr|servz|u(?:a(?:godex|ntumads)|e(?:ronamoro|st(?:ionmarket|us)|xotac)|i(?:ckcash500|nstreet))|wzmje9w|zsccm)|r(?:3seek|7e0zhv8|a(?:bilitan|ck-media|d(?:eant|i(?:calwealthformula|usmarketing))|gazzeinvendita|i(?:ggy|n(?:bowtgx|wealth))|m(?:ctrlgate|panel)|pt|wasy)|curn|d(?:dywd|ige)|e(?:a(?:ch(?:local|mode|word)|drboard|l(?:datechat|itycash|m(?:atch|edia)|securedredirect))|comendedsite|d(?:courtside|irectoptimizer|lightcenter|pineapplemedia|uxmediagroup|vase\.bravenet)|elcentric|f(?:ban|erback)|gurgical|klam(?:port|z)|l(?:atedweboffers|e(?:star|vanti)|ytec)|prak|s(?:ellerratings|i(?:deral|mler\.randevum)|pondhq|ult(?:links|s(?:page|z)))|t(?:argeter|oxo)|v(?:2pub|content|enue(?:giants|mantra)?|iewdollars|mob|res(?:da|ponse))|ward(?:isement|s(?:affiliates|tyle))|xbucks)|gadvert|h(?:gersf|own)|i(?:bbon\.india|c(?:ead|h(?:media(?:247|\.yahoo)|webmedia))|ng(?:revenue|tone(?:match|partn)er)|pplead|v(?:cash|erbanksand))|m(?:kflouh|xads)|o(?:adcomponentsdb|botadserver|cketgames|gueaffiliatesystem|i(?:a\.hutchmedia|charger|rocket)|kt|mance-net|t(?:atingad|orads)|ulettebotplus|vion|xyaffiliates|yal-cash)|ss(?:-info|\.dtiserv|pump)|tb(?:pops?|system)|u(?:biconproject|kplaza|le(?:claim\.web\.fc2|rclick)|mmyaffiliates|n(?:adtag|etki)|ssianlovematch|4)|wpads|y(?:a\.rockyou|minos))|s(?:11clickmoviedownloadercom\.maynemyltf\.netdna-cdn|2d6|a(?:\.entireweb|fe(?:cllc|li(?:nktracker|stextreme))|ilthru|l(?:ecycle|tamendors|vador24)|sc(?:dn|entral)|tgreera|vvysource|y(?:adcoltd|media))|b(?:affiliates|cpower)|c(?:an(?:medios|scout)|enesgirls|o(?:otloor|utle)|r(?:atchaffs|ibol))|e(?:a(?:l(?:\.(?:alphassl|digicert|godaddy|networksolutions|st(?:arfieldtech|ellaservice)|thawte|verisign)|server\.trustwave)|rch(?:\.twitter|peack))|c(?:coads|ondstreetmedia|retbehindporn|ur(?:e(?:-softwaremanager|\.komli|intl|p2p|websiteaccess)|it(?:ain|ymetrics)))|d(?:oparking|uctionprofits)|e(?:kbang|mybucks)|itentipp|kindo|llhealth|n(?:dptp|kinar|zari)|r(?:i(?:albay|ousfiles)|v(?:e(?:-sys|\.(?:prestige|williamhill)casino|bom|dby\.yell|meads|quake|r(?:140|\.freegamesall))|ing-sys))|sxc|t(?:ravieso|tleships)|v(?:4ifmxa|endaystart)|x(?:-journey|datecash|flirtbook|i(?:ntheuk|tnow)|list|money|o(?:le|pages)|playcam|search(?:com)?|t(?:racker|ubecash)|vertise|y(?:-ch|\.fling)))|h(?:a(?:kamech|re(?:-server|\.loginradius|a(?:holic|sale)|d\.juicybucks|gods|results|th(?:is|rough)|xy))|o(?:ogloonetwork|p(?:alyst|ilize|pingads|runner|socially)|wyoursite))|i(?:amzone|ccash|delinesapp|lstavo|m(?:p(?:io|l(?:einternetupdate|yhired|y))|usangr)|nglesexdates|t(?:e(?:brand|encore|s(?:cout(?:adserver)?|ense-oo)|three)|tiad))|josteras|k(?:i(?:m(?:link|resource)s|nected)|oovyads|y(?:activate|s(?:crpr|a)))|l(?:e(?:eknoteboxcontent\.sleeknote|ndastic)|i(?:ckdeals\.meritlin|mtrad|ns)e)|m(?:art(?:-feed-online|adserver|devicemedia|icon\.geotrust|links\.dianomi|targetting|webads)|il(?:eycentral|yes4u)|owtion|pgfx|s-(?:mmm|xxx)|utty)|nap(?:widget)?|o(?:-excited|c(?:hr|i(?:al(?:annex|birth|elective|lypublish|m(?:arker|edia(?:buttons|tabs)?)|oomph|re(?:ach|st)|s(?:ex|park)|twist|vibe)|ety6|o(?:cast|mantic)))|d(?:ahea|u)d|ft(?:4dle|onicads|popads)|kitosa|l(?:a(?:pok|rmos)a|ocpm|utionsadultes)|nobi|phiasearch)|p(?:arkstudios|cwm|e(?:c(?:ificmedia|tato)|e(?:dshiftmedia|b))|i(?:ceworks|nbox\.freedom)|l(?:azards|inky|ut)|mxs|o(?:n(?:gecell|sor(?:edtweets|mob|palace|select))|rtsyndicator|t(?:rails|tt|xchange))|r(?:intrad|oos)e|unkycash)|q(?:2trk2|ueeder)|rv(?:2trking|pub)|t(?:a(?:cka(?:dapt|ttacka)|lesplit|ndartads|r(?:gamesaffiliate|layer|t(?:appexchange|ede|pagea|webpromo))|t(?:elead|ic\.delicious|strackeronline))|e(?:althlockers|pkeydo)|i(?:ckyadstv|pple)|or(?:e\.lavasoft|ystack)|r(?:eam(?:ate(?:access)?|downloadonline)|i(?:kead(?:cdn\.s3\.amazonaws)?|psaver)|uq)|yld-by)|u(?:bscriptiongenius|ggesttool|ite(?:6ixty6ix|smart)|nnysmedia|p(?:arewards|er(?:loofy|sitetime)|ply(?:\.upjers|frame)|remeadsonline)|rvey(?:-poll|\.constantcontact|end|gizmo|monkey|s(?:paid|tope))|thome)|w(?:bdds|e(?:etstudents|len)|i(?:shu|tchadhub)|oop)|y(?:mbiosting|n(?:cedvision|dicate(?:\.payloadz|dsearchresults))))|t(?:3(?:q7af0z|sort)|a(?:boola(?:syndication)?|c(?:astas|ticalrepublic)|fmaster|g(?:\.regieci|junction|shost)|ilsweep|kensparks|l(?:aropa|k-blog)|ngozebra|p(?:ad|joyads)|r(?:dangro|get(?:\.vivid|adverts|ingnow|net|point|spot))|ttomedia)|baffiliate|d553|e(?:a(?:mbetaffiliates|ser(?:net|vizio))|ch(?:-board|norati(?:media)?)|endestruction|osredic|racreative|stfilter|xt(?:onlyads|srv))|gtmedia|h(?:e(?:-adult-company|bunsenburner|echosystem|l(?:istassassin|o(?:ungenet|vebucks))|midnightmatulas|payporn|rewardsurvey|s(?:lingshot|ocialsexnetwork)|traderinpajamas|w(?:ebgemnetwork|heelof))|irdpartycdn\.lumovies|o(?:seads|ughtleadr)|umbs\.sunporno)|i(?:daltv|mteen|n(?:buadserv|grinter|ker|y(?:pass|weene))|s(?:adama|er)|zernet)|k(?:high|qlhce)|l(?:dadserv|vmedia)|mserver-1|o(?:boads|days(?:finder|sn)|kenads|llfreeforwarding|mekas|nefuse|ol(?:-site|bar(?:\.(?:avg|cdn\.gigya)|plex)|s\.gfcash)|p(?:-sponsor|auto10|b(?:inaryaffiliates\.ck-cdn|ucks)|casino10|hotoffers|relatedtopics|sy)|r(?:conpro|oadvertising(?:media)?|rentdeluxe)|ssoffads|t(?:alprofitplan|emcash)|ur(?:\.(?:cum-covered-gfs|mrskin)|s\.imlive))|pnads|qlkg|r(?:a(?:ceadmanager|de(?:doubler|p(?:opups|ub)|r\.erosdlz)|ffirms|pasol|v(?:el(?:advertising|scream)|idia))|e(?:direct|ndemon)|i(?:admedianetwork|balfusion|gami)|k(?:alot|er|4)|trccl|ust(?:edadserver|logo)|w12|y9)|t(?:lmodels|zmedia)|u(?:b(?:berlo|e(?:adnetwork|dspots|mogul|replay))|enti|rnsocial|sno|tvp)|vprocessing|w(?:a(?:ckle|lm)|e(?:ard|et(?:board|grid|meme|river|up))|i(?:lightsex|np(?:inenetwork|lan)|st(?:ads|yscash)|t(?:buttons|t(?:ad|er(?:counter|forweb|icon|mysite)|his)))|tad)|yroo)|u(?:1hw38x0|budigital|g(?:aral|hus|lyst)|i(?:adserver|qatnpooq)|n(?:aspajas|dertone|i(?:cast|tethecows|versityofinternetscience)|lockr|rulymedia|terary)|p(?:liftsearch|tolike)|reace|s(?:e(?:net(?:junction|passport)|rcash)|urv)|t(?:okapa|ubeconverter)|xernab)|v(?:11media|2cigs|a(?:dpay|l(?:idclick|ue(?:ad|c(?:lick(?:media)?|ommerce)))|pedia)|c(?:media|ommission)|dopia|e(?:ctor(?:pastel|stock)|l(?:lde|ti)|mba|ndexo|oxa|r(?:s(?:ahq|etime)|ticalaffiliation))|hm(?:engine|network)|i(?:anadserver|brantmedia|d(?:eo(?:-(?:loader|people)|adex|deals|egg|hub|l(?:ansoftware|ogygroup)|plaza|sz|zr)|pay)|ew(?:clc|ivo|scout)|ndicosuite|p(?:cpms|questing)|rtuagirlhd|si(?:ads|blegains|t(?:\.homepagle|details|web))|vidcash)|l(?:exokrako|ogexpert)|ntsm|o(?:d-cash|go[ps]ita|odoo|tes\.buzz\.yahoo|yeurbase)|p(?:ico|rmnwbskk)|rstage|s(?:20060817|4(?:entertainment|family)|erv\.bc\.cdn\.bitgravity)|th05dse|u(?:ngle|vuplaza))|w(?:00tads|3exit|a(?:ddr|gershare|h(?:anda|oha|wahnetworks)|lprater|m(?:cash|network)|ptrick|r(?:facco|somnet)|ter(?:istian|soul)|ymp)|b(?:ptqzmv|sadsdel2?)|cpanalytics|e(?:alth-at-home-millions|b(?:advertise123|c(?:am(?:bait|promotions|s)|lick(?:engine|manager))|engage|gains|master\.erotik|s(?:e(?:curity\.norton|eds)|ite(?:alive5?|promoserver))|trackerplus|usersurvey)|gotmedia|heartit|liketofuckstrangers|nsdteuy|tpeachcash|workremotely)|fnetwork|greatdream|h(?:5kb0u4|a(?:leads|tsapp-sharing)|tsrv9)|i(?:dget(?:\.(?:adviceiq|breakingburner|c(?:hipin|lipix|rowdignite)|firefeeder|imshopping|jobberman|p(?:rnewswire|ushbullet)|s(?:coutpa|tagram)|weibo|yavli)|bucks|cf\.adviceiq|s(?:\.(?:adviceiq|b(?:acktype|ufferapp)|d(?:igg|zone)|fccinteractive|getpocket|itunes\.apple|mobilelocalnews|outbrain|progrids|seekitlocal|t(?:ap(?:cdn|iture)|rustedshops|wimg))|plus))|felovers|get(?:media|studios)|l(?:d(?:hookups|match)|liamhill)|n(?:buyer|gads)|th(?:-binaryoption|binaryoptions))|lmarketing|mmediacorp|o(?:n(?:click|derlandads)|od-pen|pdi|r(?:d(?:bankads|ego)|ld(?:datinghere|sbestcams)|th(?:athousandwords|yadvertising)))|pcomwidgets|rapper\.ign|sockd|u(?:lium|rea)|w(?:bn|v4ez0n|w(?:adcntr|mobiroll|promoter))|zus1\.ask|4)|x(?:3v66zlz|4300tiz|\.mochiads|ad(?:central)?|c(?:el(?:ltech|siusadserver)|lickdirect|rsqg)|eontopa|f(?:s5yhr1|uckbook)|hamstercams|ing-share|jfjx8hw|lovecam|m(?:asdom|lconfig\.ltassrv)|nxx|oliter|p(?:eeps|ollo)|s\.mochiads|t(?:cie|end(?:advert|media))|ubob|vika|x(?:ltr|x(?:allaccesspass|b(?:lackbook|unker)|ex|lnk|match|vipporno))|ylopologyn)|y(?:72yuyr9|a(?:88s1yk|buka|domedia|zcash)|b0t|e(?:abble|s(?:-messenger|adsrv|messenger|nexus)|xt)|fum|ield(?:ad(?:vert|s)|build|kit|m(?:anager|o)|optimizer|select|x)|l(?:dbt|lix)|mads|o(?:bihost|ntoo|oclick|pdi|shatia|ttacash|u(?:candoitwithroi|l(?:amedia|ouk)|r(?:-(?:big|tornado-file)|adexchange|datelink|fastpaydayloans|quickads|voyeurvideos)))|p(?:madserve|pr)r|u(?:0123456|arth|cce|menetworks|ppads|vutu)|voria|z(?:56lywd|rnur|us09by))|z(?:4pick|a(?:n(?:gocash|ox)|p(?:arena|united))|de-engage|e(?:ads|do|esiti|manta|novia(?:exchange|group)|r(?:cst|ez)as)|f(?:acts|erral)|i(?:dae|ffdavis|p(?:hentai|ropyl))|naptag|o(?:mpmedia|n(?:ealta|plug))|ugo|ypenetwork))\.com$/,
	/(?:^|\.)(?:1sadx|2(?:47teencash|mdn)|4affiliate|777(?:-partners?|partner)|888media|9newstoday|a(?:2dfp|bnad|cf-webmaster|d(?:-(?:ba(?:ck|lancer)|delivery|srv)|advisor|b(?:a(?:r[ds]|sket)|ooth|ureau)|c(?:astplus|loud)|dynamo|f(?:01|orm)|g(?:ine|lamour)|hese|impression|juggler|k(?:ick|2)|l(?:ayer|ink|ure)|m(?:a(?:gnet|rketplace)|i(?:ssion|xer))|n(?:et(?:-media|work)|xs)|orika|p(?:arad|rs)|rent|s(?:2ads|-elsevier|campaign|f(?:ac(?:tor)?|undi)|mws\.cloudapp|next|r(?:evenue|vmedia)|sites|ummos)|t(?:egrity|ransfer)|ult(?:advertising|commercial|imate)|v(?:erserve|iva|9)|worldmedia|zerk)|f(?:fiz|y11)|jansreklam|llianrd|m15|n(?:doh|rdoezr)s|ppr8|rtbr|tomex|vazu|waps)|b(?:e(?:coquins|ead)|h3|i(?:ankord|gadpoint|tads)|l(?:ipi|uazard)|r(?:and(?:affinity)?|ightcpm)|uzzcity)|c(?:-planet|am(?:-lolita|ads)|dn(?:\.nsimg|cache2-a\.akamaihd)|entralnervous|h(?:an(?:ished|siar)|i(?:tik|uaw)a|tic)|itysite|jt1|l(?:ick(?:ansave|b(?:ank|ubbles)|e(?:quation|xpert)s|intext|kingdom|sor|ter)|oudharmony|z3)|o(?:digobarras|gocast|inadvert|llective-media|mpoter|n(?:ne(?:ctedads|xity)|te(?:nt(?:\.webcollage|cache-a\.akamaihd|olyze|widgets|r)|xtads))|uponcp-a\.akamaihd)|pmmedia|r(?:azyad|iteo)|ursors-4u)|d(?:\.m3|a(?:pper|shboardad|texchanges)|e(?:als\.buxr|cknetwork|player|siad)|o(?:mri|uble(?:click|max)?|wnloadandsave-a\.akamaihd)|pbolvw|raugonda|sero|vaminusodin)|e(?:-planning|blastengine\.upickem|d(?:abl|omz)|l(?:asticad|vate)|ngine\.gamerati|rger(?:ww|s)|sults|trader\.kalahari|veryporn|yewond\.hs\.llnwd|z(?:adserver|oic))|f(?:a(?:ce(?:bookicon|tz)|lkag|st(?:a(?:pi|tes)|click))|eedage|i(?:ckads|ndbestsolution)|l(?:a(?:gads|urse)|ipflapflo|lwert)|mpub|o(?:rex-affiliate|war)|reedownloadsoft|usionads)|g(?:adgetresearch|e(?:ek2us|ld-internet-verdienen|oaddicted)|ghfncd|iantsavings-a\.akamaihd|lobal(?:-success-club|adv|takeoff)|mads|o(?:findmedia|viral\.hs\.llnwd)|scontxt)|h(?:a(?:pnr|vamedia)|dvid-codecs-dl|illtopads|o(?:bri|stave4|tfeed)|ypemakers)|i(?:friends|giplay|mg(?:-giganto|\.servint)|n(?:nity|sta(?:-cash|email)|t(?:e(?:ntmedia|r(?:activespot|m(?:arkets|rkts\.vo\.llnwd)|nebula)|xtual)|gr))|unbrudy|wantmoar)|j(?:ackao|dproject|ellr|que|ssearch|u(?:ic(?:eadv|ycash)|ruasikr))|k(?:9x|erg|ingpinmedia|orrelate|rxd|uangard)|l(?:duhtrp|e(?:ad(?:acity|bolt)|g(?:acyminerals|island))|i(?:ghtningcast|nk(?:exchangers|offers|storm|z)|qwid|veadserver))|m(?:5prod|a(?:kemoneymakemone|rketfl)y|dadvertising|ed(?:ia(?:-(?:server|k)s|lation|onenetwork)?|yanet)|icrosoftaffiliates|mngte|o(?:bizme|nkeybroker|vad)|pression|sads|y(?:-layer|\.leadpages|cooliframe|playerhd|webclick))|n(?:e(?:t(?:flixalternative|shelter|worldmedia)|wtention)|gbn|mwrdr|owlooking|ubiles|vero)|o(?:ddads|ldtiger|n(?:clickads|enetworkdirect|hitads|lyalad|sitemarketplace)|p(?:en(?:-downloads|book)|t(?:-n|iad))|taserve)|p(?:a(?:gefair|id(?:-to-promote|onresults))|eer39|i(?:ctela|kkr|xfuture)|l(?:inx|u(?:gin\.me2day|sfind))|o(?:lyad|p(?:-bazar|ads(?:cdn)?|cash|ularmedia)|rn(?:88|99)|werfulbusiness)|pjol|r(?:ivateseiten|o(?:-market|fistats|gramresolver|tally))|tp\.lolco|u(?:b(?:licidad|serve)|rpleflag))|q(?:ks(?:rv|z)|wobl)|r(?:cads|e(?:a(?:dserver|lvu)|d(?:cash|intelligence)|gersd|poro|s(?:earch|pecific)|targetpro|v(?:fusion|sci))|fihub|nmd|ocketier|tbidder)|s(?:a(?:feadnetworkdata|ncdn|ple|veads)|creencapturewidget\.aebn|e(?:ekads|l(?:ectr|lpoint|sin)|nzapudore|rvali|venads|x(?:ad|ypower))|hare\.static\.skyrock|ilverads|ma(?:ato|rt(?:erdownloads|targetting))|n00|o(?:cialsexnetwork|nnerie)|p(?:e(?:cificclick|edsuccess)|i(?:derhood|nbox))|rtk|t(?:at(?:-data|camp|ictapcdn-a\.akamaihd)|ipple\.cachefly|ocker\.bonnint)|u(?:blimemedia|nmedia|per-links|rveyvalue)|vlu|xrrxa|yncaccess)|t(?:a(?:coda|ggify)|e(?:chclicks|lemetryverification|racent)|h(?:4wwe|epiratereactor|rilamd|umbnail-galleries)|itsbro|m(?:-core|server-2)|o(?:p(?:26|di)|rr(?:ida|pedoads)|tal-media)|qlkg|r(?:a(?:de(?:expert|tracker)|f(?:fboost|ogon)|velmail\.traveltek)|kclk|ndi)|u(?:mri|rbotraff))|u(?:dmserve|nlimedia|pdater-checker|r(?:bation|l(?:ads|cash)))|v(?:alue(?:affiliate|c(?:lick|ontent))|e(?:lmedia|r(?:-pelis|ify\.authorize))|i(?:ewablemedia|sualsteel|talads|vamob)|ktr073|roll|sservers|uiads)|w(?:00tmedia|cmcs|e(?:b(?:searchers|utation)|getpaid)|hy-outsource|idget(?:lead|s\.itaringa|value)|o(?:otmedia|rldrewardcenter)|u(?:a(?:rnurf|triser)|dr))|x(?:clicks|graph|mediawebs|vika|xlink)|y(?:ardr|ceml|ield(?:lab|manager(?:\.edgesuite)?)|ldmgrimg|o(?:br|dr|mri)|tsa)|z(?:5x|mh\.zope|omri|rfrornn|xxds))\.net$/,
	// Intrusive (03 Apr 2015 17:10 UTC)
	/(?:^|\.)(?:12mlbe|8yxupue8|a(?:2a\.lockerz|\.(?:eporner|giantrealm|heavy-r|i-sgcm|jango|killergram-girls|vpsboard|watershed-publishing)|c(?:2\.msn|cess\.njherald|ookie\.alibaba|t(?:ivit(?:ies\.niagaraedycentral|y\.(?:frequency|homescape))|onsoftware)|uityplatform)|d(?:citrus|d(?:irector\.vindicosuite|s\.weatherology)|guru\.guruji|kengage|mxr|n\.ebay|s(?:-(?:grooveshark|rolandgarros)|att\.(?:abcnews|espn)\.starwave|by\.klikki|hare\.freedocast|iplytmedia\.indiatimes|or\.openrunner|rpt|s\.yahoo|t(?:atic|il\.indiatimes)|yndication\.msn)|test\.theonion|v(?:\.(?:drtuber|h2porn)|an(?:cedtracker\.appspot|senow))|wiretracker\.fwix)|ffddl\.automotive|g(?:endaplex|ilone)|is\.abacast|katracking\.esearchvision|lter-shopping|m(?:azon-adsystem|p\.virginmedia|z\.steamprices)|na(?:ly(?:\.qq|sis\.focalprice|tics(?:-v2\.anvato|engine\.s3\.amazonaws)|ze(?:\.(?:full-marke|yahooapis)|r(?:5[12]|2)?\.fc2))|pixel\.(?:aprendeingles|expansion|marca|telva))|p(?:i\.(?:fyreball|wipmania)|p\.(?:bronto|insightgrit))|rd\.(?:ihookup|sweetdiscreet)|s(?:\.inbox|erve\.directorym|sets\.olark)|t(?:ax\.(?:game(?:rmetrics|s(?:py|tats))|ign|teamxbox)|gsvcs|las\.astrology|rack(?:\.a(?:llposters|rt)|tive\.collegehumor)|tributiontrackingga\.googlecode)|udienceserver\.aws\.forebase|vpa\.dzone|weber|xislogger\.appspot)|b(?:92\.putniktravel|\.(?:b(?:abylon|edop)|grvcdn|huffingtonpost|imwx|localpages|myspace)|a(?:bm\.texthelp|rium\.cheezdev|t\.adforum)|c(?:\.yahoo|analytics\.bigcommerce|m\.itv)|ea(?:con(?:2\.indieclick|-1\.newrelic|\.(?:e(?:how|rrorception|xaminer)|gcion|heliumnetwork|indieclick(?:tv)?|lycos|nuskin|richrelevance|se(?:arch\.yahoo|curestudies)|www\.theguardian)|s\.helium)|p\.gemini\.yahoo)|i(?:\.medscape|gmobileads|t\.ehow|zsolutions\.strands)|l(?:a(?:aaa12\.googlecode|mads-assets\.s3\.amazonaws)|og(?:ads|gerbersatu))|n\.premiumhdv|o(?:b\.crazyshit|ldchat|ngacash|td2?\.wordpress)|r(?:\.(?:blackfling|fling|realitykings)|anica|cache\.madthumbs|ight\.bncnt|owsertest\.web\.aol)|t(?:n\.clickability|r(?:\.domywife|ace\.qq))|u(?:dbi|nsen\.wapolabs|zz(?:box\.buzzfeed|deck))|zclk\.baidu)|c(?:2s-openrtb\.liverail|3metrics\.medifast1|4tracking01|\.(?:homestore|microsoft|newsinc|x\.oanda)|a(?:che2\.delvenetworks|d(?:reon\.s3\.amazonaws|vv\.(?:heraldm|koreaherald))|nvas-(?:ping|usage-v2)\.conduit-data|ptora|s(?:\.clickability|h\.neweramediaworks))|b(?:proads|s\.wondershare)|d\.musicmass|e(?:\.lijit|rebral\.typn)|f\.overblog|h(?:analytics\.merchantadvantage|kpt\.zdnet)|jmooter\.xcache\.kinxcdn|l(?:\.expedia|arity\.abacast|ck\.yandex|ick(?:p(?:apa|rotector)|stream\.loomia|tale\.pantherssl)|k(?:\.about|ads|mon|rev|stat\.qihoo)|o(?:g\.go|udfront(?:-labs\.amazonaws|\.brainient))|s\.ichotelsgroup)|ms(?:-pixel\.crowdreport|trendslog\.indiatimes)|nt\.n(?:icemix|uvid)|o(?:inurl|l(?:lect(?:2\.sas|\.(?:igodigital|sas)|ion\.(?:acromas|theaa)|or(?:-cdn\.github|\.(?:githubapp|ks(?:ax|tptv5)|statowl|tescocompare)))|odin\.s3\.amazonaws)|m\.econa|n(?:firm-referer\.glrsales|ta(?:dores\.miarroba|tore-di-visite\.campusanuncios))|o(?:kie(?:\.oup|x\.ngd\.yahoo)|lertracks\.emailroi)|unt\.(?:c(?:arrierzone|hanneladvisor)|newhua|paycounter|qiannao))|p(?:ete|m(?:\.amateurcommunity|rocket))|r(?:eatives\.(?:cliphunter|inmotionhosting|livejasmin|pichunter)|m-metrix)|si\.gstatic|t(?:\.(?:buzzfeed|needlive)|s\.vresp)|urate\.(?:nestedmedia|venturebeat)|x\.atdmt)|d(?:\.(?:annarbor|businessinsider|gossipcenter|shareaholic|thelocal)|a(?:\.virginmedia|ds\.new\.digg|ily(?:deals\.(?:a(?:marillo|ugustachronicle)|brainerddispatch|lubbockonline|onlineathens|savannahnow)|motion-ams\.gravityrd-services|video\.securejoin)|rt\.clearchannel|ta(?:\.(?:alex|econ|neuroxmedi)a|collector\.coin\.scribol))|bam\.dashbida|c(?:\.letv|ad\.watersoul|s\.mattel)|eal(?:media\.utsandiego|s\.ledgertranscript)|i(?:ag\.doba|et\.rodale|gdug\.divxnetworks|s(?:play\.digitalriver|tillery\.wistia))|j(?:\.renren|ibeacon\.djns)|m(?:eserv\.newsinc|ros\.ysm\.yahoo|tracking2\.alibaba)|o(?:ntblockme\.modaco|t2?\.eporner)|w(?:\.c(?:bsi|net)|tracking\.sdo)|ynamicyield)|e(?:a\.(?:clubic|jeuxvideopc|monsieurmanuel)|bay\.northernhost|c(?:2-prod-tracker\.babelgum|lick\.baidu)|dw\.edmunds|marketing\.rmauctions|n(?:25|lightenment\.secureshoppingbasket|try-stats\.huff(?:ington)?post)|powernetworktrackerimages\.s3\.amazonaws|qads|s\.puritan|t(?:\.(?:grabnetwork|nytime)|rk\.asu)s|u(?:ltech\.fnac|m-appdynamics|widget\.imshopping)|v(?:a\.ucas|ent(?:\.(?:previewnetworks|trove)|log(?:\.inspsearch(?:api)?|ger\.soundcloud)|s\.(?:kalooga|realgravity)|tracker\.elitedaily))|x(?:it\.macandbumble|p(?:bl2ro\.xbox|db2\.msn|o-max)|t(?:\.theglobalweb|ensionmaker)))|f(?:\.staticlp|ast(?:\.forbes|counter\.bcentral)|e(?:eds\.logicbuy|litb\.rightinthebox)|i(?:lament-stats\.herokuapp|mserve\.ign|ndnsave\.idahostatesman)|l(?:ashstats\.libsyn|ite|s-na\.amazon)|orms\.windowsitpro|r(?:esh\.techdirt|iends\.totallynsfw|og\.wix)|t\.pnop)|g(?:2a|\.(?:brothersoft|msn)|a(?:meads\.digyourowngrave|t(?:eway(?:\.fortunelounge|s\.s3\.amazonaws)|her\.hankyung))|e(?:o(?:\.(?:c(?:liphunter|onnexionsecure)|homepage-web|ltassrv|mtvnn|perezhilton|yahoo)|bar\.ziffdavisinternational|ip\.(?:cleveland|gulflive|lehighvalleylive|m(?:ass)?live|n(?:ola|j)|oregonlive|pennlive|s(?:iliv|yracus)e|viamichelin))|tsidecar(?:\.s3\.amazonaws)?)|fx\.infomine|l(?:bdns\.microsoft|ean\.pop6)|monitor\.aliimg|o\.(?:optifuze|theregister)|r(?:e(?:en\.virtual-nights|pdata)|t01)|scounters\.(?:eu1\.|us1\.)?gigya)|h(?:\.cliphunter|arvester\.ext\.square-enix-europe|i(?:\.hellobar|t(?:count\.heraldm|s\.(?:antena3|dealer|informer)|web2\.chosun))|k\.ndx\.nextmedia|optopboy)|i(?:\.cbsi|a(?:d(?:c\.qwapi|vize)|srv)|b(?:eat|s)\.indiatimes|ctv-ic-ec\.indieclicktv|d(?:\.allegisgroup|eoclick)|edc\.fitbit|llyx|m(?:a(?:3vpaid\.appspot|ds\.rediff)|g(?:lb\.yobihos|track\.domainmarke)t|massets\.s3\.amazonaws|onitor\.dhgate|xedycentral)|n(?:dieclick\.3janecdn|fusionsoft|quiries\.redhat|sights\.gravity|telligence\.dgmsearchlab)|socket|vw\.fem)|j(?:\.maxmind|a(?:ck\.allday|vascriptcounter\.appspot)|obs\.(?:hrkspjbs|mashable)|sadapi)|k(?:alstats\.kaltura|e(?:rmit\.macn|yword\.daumd)n|inesisproxy\.hearstlabs)|l(?:\.(?:5min|ooyala|player\.ooyala|sharethis)|aurel\.(?:macrovision|rovicorp)|cs\.naver|eadtracking\.plumvoice|h\.secure\.yahoo|i(?:nk\.(?:americastestkitchencorp|informer)|ve(?:\.philips|person))|l\.a\.hulu|o(?:g(?:\.(?:d(?:ata\.disney|eutschegrammophon)|go|hiiir|ideamelt|kibboko|liverail|newsvine|o(?:lark|ptimizely|utbrain)|pinterest|r7|v\.iask|wilmaa|ynet)|g(?:er\.(?:dailymotion|sociablelabs)|ing(?:\.wilmaa|api\.spingo|services\.tribune))|inlog\.sdo|s(?:\.(?:dashlane|live\.tudou|vmixcore)|sl\.enquisite|tat\.caixin))|madee)|s(?:am\.research\.microsoft|lmetrics\.djlmgdigital)|unametrics\.wpengine\.netdna-cdn|w(?:1\.cdmedia|2\.gamecopy)world)|m(?:2\.xhamster|\.trb|a(?:ds\.aol|gnify360-cdn\.s3\.amazonaws|ilmunch\.s3\.amazonaws|rket(?:ing\.888|o))|b\.(?:hockeybuzz|zam)|cs\.delvenetworks|e(?:alsandsteals\.sandiego6|d(?:ia(?:-(?:delivery|mgmt)\.armorgames|m(?:etrics\.mpsa|gr\.ugo))|yanetads)|t(?:er-svc\.nytimes|rics-api\.librato))|i(?:croreporting\.metrofrance|newhat|tel\.marketbright)|mpstats\.mirror-image|obisupreme)|n(?:\.yunshipei|avlog\.channel4|b\.myspace|e(?:d\.itv|t(?:affiliation|spidermm\.indiatimes|work\.(?:aufeminin|business)))|mtracking\.netflix|o(?:l\.yahoo|problemppc|ram\.srv\.ysm\.yahoo)|plexmedia|s(?:\.rvmkitt|click\.baidu|tat\.tudou)|vc\.n1bus-exp|ws\.naltis)|o(?:\.addthis|ascentral\.(?:chron|newsmax)|ffermatica\.intuit|img\.m(?:obile)?\.cnbc|m(?:\.cbsi|niture\.theglobeandmail)|n(?:\.maxspeedcdn|espot-tracking\.herokuapp|lineadserv)|pen\.mkt1397|rigin(?:-tracking\.trulia|\.chron)|utbrowse|x-d\.wetransfer)|p(?:-log\.ykimg|\.tanx|artner(?:\.(?:bargaindomains|c(?:atchy|ynapse)|premiumdomains)|ads1?\.ysm\.yahoo|s(?:-z|\.(?:badongo|fshealth|mysavings|optiontide|pornerbros|rochen|thefilter|x(?:hamster|pertmarket))))|b\.i\.sogou|click\.(?:europe\.|internal\.)?yahoo|erformances\.bestofmedia|g\.buzzfeed|hoenix\.untd|i(?:\.feedsportal|ng(?:\.(?:aclst|dozuki|hellobar)|back\.sogou|js\.qq|s\.conviva)|pe(?:dream\.wistia|line\.realtime\.active)|x(?:\.impdesk|el(?:\.(?:colorupmedia|fa(?:cebook|nbridge)|klout|newscred|pcworld|reddit(?:media)?|s(?:olvemedia|taging\.tree)|tree|vmm-satellite2|wp|y(?:abidos|ola))|counter\.(?:aprendeingles|expansion|marca|telva)|s\.livingsocial)|iedust\.buzzfeed))|metrics\.performancing|o(?:cketcents|p(?:-over\.powered-by\.justplayzone|it\.mediumpimpin|upxxx)|s(?:\.baidu|tpixel\.vindicosuite)|und\.buzzfeed)|p-serve\.newsinc|r(?:-static\.(?:emp|tna)flix|\.blogflux|e(?:rollads\.ign|sentationtracking\.netflix)|iceinfouv|o(?:ac\.nationwide|mo(?:\.(?:a(?:dult-empire|verotica)|badoink|f(?:ileforum|reecamstars)|lonelywifehookup|pimproll)|s\.fling|t(?:e\.pair|ions\.iasbet))|xypage\.msn)|stats\.postrelease)|t(?:\.crossmediaservices|sc\.shoplocal)|ub(?:\.betclick|liclix|matic|s\.hiddennetwork)|x(?:\.excitedigitalmedia|lctl\.elpais))|q(?:\.stripe|os\.video\.yimg|ubitanalytics\.appspot)|r(?:\.msn|a(?:\.ripple6|d\.m(?:icrosoft|sn)|inbow-uk\.mythings|nking\.ynet)|cgi\.video\.qq|d\.meebo|e(?:achjunction|co(?:\.hardsextube|mmendation\.24)|deye\.williamhill|ferrer\.disqus|l\.msn|port(?:\.(?:qq|shell)|ing\.(?:flymonarch|singlefeed|theonion|wilkinsonplus)|s\.maxperview)|quest\.issuu|s3\.feedsportal|v(?:\.fapdu|e(?:alads\.appspot|n(?:uehits|you))|sci\.tvguide))|ich(?:-agent\.s3\.amazonaws|media\.yimg)|oi(?:track\.addlvr|a)|t(?:\.(?:globo|prnewswire)|t\.campanja))|s(?:1magnettvcom\.maynemyltf\.netdna-cdn|2\.youtube|-yoolk-billboard-assets\.yoolk|\.(?:clickability|m2pub|qhupdate|renren|sniphub|update\.entrepreneur|youtube)|a(?:\.(?:bbc|squareup)|femetric|na\.newsinc|yac\.hurriyettv)|b\.vevo|c(?:lick\.baidu|out\.(?:lexisnexis|rollcall)|ri(?:be\.twitter|pts\.psyma))|e(?:archignited|g\.sharethis|nse\.dailymotion|rv(?:e(?:dby\.keygamesnetwork|r\.promodity)|icetick)|ssion-tracker\.badcreditloans|xtronix\.nyk-b2\.c\.pnj1\.cdnaccess)|h(?:are\.baidu|inystat\.lvlar|oppingpartners2\.futurenet)|i(?:debar\.issuu|te(?:\.img\.4tube|life\.ehow|reports\.officelive))|lot\.union\.ucweb|m(?:artsuggestor|etrics\.delta)|n(?:apengage|ippets\.mozilla|owplow-collector\.sugarops)|omniture\.theglobeandmail|p(?:a(?:cedust\.netmediaeurope|nids\.(?:dictionary|reference|thesaurus))|e(?:ctate|edtrap\.shopdirect)|o(?:nsor(?:pay|s\.(?:s2ki|webosroundup))|ods\.rce\.veeseo|tlight\.accuweather))|r(?:t\.pch|v\.(?:aileronx|thespacereporter))|s(?:acdn|l-stats\.wordpress)|t(?:\.fanatics|a(?:\.ifeng|dig\.ifeng|t(?:db\.pressflex|i(?:c\.kinghost|stic(?:\.qzone\.qq|s\.(?:crowdynews|rbi-nl|tattermedia|wibiya)))|m\.the-adult-company|s(?:-newyork1\.bloxcms|analytics|dev\.treesd|rv\.451)|t(?:-collect\.herokuapp|rack\.0catch)|ystyki\.panelek))|bt\.coupons|collection\.moneysupermarket|g\.nytimes|r(?:eamstats1\.blinkx|tsrv))|u(?:\.addthis|gar\.gameforge|per(?:fish|sonicads)|rv(?:\.xbizmedia|ey(?:\.interques|s\.cne)t))|ystemmonitoring\.badgeville)|t(?:2\.hulu(?:im)?|4\.trackalyzer|-(?:ak\.hulu|staging\.powerreviews)|\.(?:bimvid|eharmony|flux|menepe|p(?:aypal|swec)|vimeo)|a(?:g(?:-stats\.huffpost|\.(?:email-attitude|myplay|sonymusic)|s\.m(?:aster-perf-tools|snbc))|nzanite\.infomine|rgeted(?:info|topic))|ck\.bangbros|elemetryaudit|h(?:e(?:blogfrog|jesperbay|mis\.yahoo|tradedesk-tags\.s3\.amazonaws)|rivehive)|i(?:me(?:anddate|strends\.indiatimes)|nglog\.baidu)|ns\.simba\.taobao|o(?:m\.itv|p\.wn|ruk\.tanx|tal\.shanghaidaily)|r(?:-metrics\.loomia|a(?:c(?:e(?:log\.www\.alibaba|r\.perezhilton)|ker-id\.cdiscount|y\.sadv\.dadapro)|x\.(?:dirxion|tvguide))|c(?:\.taboolasyndication|k\.sixt)|ee-pixel-log\.s3\.amazonaws|f\.intuitwebsites|iad\.technorati|k\.vindicosuite|ueffect\.underarmour)|uberewards|w(?:\.i\.hulu|itter-badges\.s3\.amazonaws)|xn\.(?:grabnetworks|thenewsroom))|u(?:a\.badongo|dc\.msn|estat\.video\.qiyi|n(?:icast\.(?:ig|ms)n|stat\.baidu)|p(?:\.(?:boston|nytimes)|tpro\.homestead)|r(?:c\.taboolasyndication|lcheck\.hulu)|serfly|t(?:\.ratepoint|rack\.hexun))|v(?:alf\.atm\.youku|cita|e(?:ndor1\.fitschigogerl|r(?:dict\.abc\.go|tical-stats\.huff(?:ington)?post))|i(?:deo(?:-(?:ad-stats\.googlesyndication|stats\.video\.google)|tracker\.washingtonpost)|ew\.atdmt|rgul|si(?:ons3x|t(?:\.(?:dealspwn|geocities|theglobeandmail|webhosting\.yahoo)|ors\.sourcingmap)))|oss\.collegehumor|s(?:\.target|tat\.vidigy)|ty\.dailymotion|zert)|w(?:88\.(?:m\.espn\.)?go|atson\.live|dm\.map24|e(?:b(?:click(?:\.yeshj|tracker)|effective\.keynote|log(?:\.strawberrynet|ger(?:01\.data\.disney|-dynamic-lb\.playdom))|master\.extabit|overnet|s(?:ervices\.websitepros|itealive7)|tracker\.(?:apicasystem|educationconnection))|knownet)|h(?:atismyip\.akamai|ere|istleout\.s3\.amazonaws|oson\.smcorp)|i(?:biya-(?:actions|june-new-log)\.conduit-data|dget(?:\.(?:directory\.dailycommercial|kelkoo|perfectmarket|quantcast|raaze|searchschoolsnetwork)|ssec\.cam-content)|nter\.metacafe)|oopra|ptrak|rmwb\.7val|stat\.wibiya|usstrack\.wunderground|zus(?:1\.(?:reference|thesaurus)|\.askkids))|x(?:\.weather|targeting)|y(?:ashi|b\.torchbrowser|e(?:a\.uploadimagex|sware)|nuf\.alibaba)|z(?:apads\.zapak|opim))\.com$/,
	/(?:^|\.)(?:a(?:\.(?:cdngeek|kickassunblock|ucoz)|d(?:butter|m(?:aster|eta\.vo\.llnwd)|netinteractive|ru|s(?:peed|s\.dotdo)|v\.letitbit)|ffl\.sucuri|jnad\.aljazeera|ksb-a\.akamaihd|udit\.303br|ward\.sitekeuring)|b(?:a\.(?:ccm2|kioskea)|eacons\.brandads|loggerads|ox\.anchorfree|stracker\.blogspirit|uzzbytes)|c(?:\.bigmir|cmbg|li(?:ckt(?:alecdn\.sslcs\.cdngc|racks\.aristotle)|entstat\.castup)|n(?:\.cbsimg|t\.(?:3dmy|mastorage))|o(?:llect\.finanzen|met\.ibsrv))|d(?:1(?:3(?:4l0cdryxgwa|czkep7ax7nj)|5(?:565yqt7pv7r|gt9gwxw5wu0)|7f2fxw547952|9972r8wdpby8|a(?:de4ciw4bqyc|f033869koo7)|c(?:dnlzf6usiff|erpgff739r9|l(?:1sqtf3o420|fvuu2240eh))|d95giojjkirt|e(?:p3cn6qx0l3z|y3fksimezm4)|fo96xm8fci0r|g(?:ojtoka5qi10|p8joe0evc8s)|k74lgicilrr3|lm7kd3bd3yo9|n(?:h2vjpqpfnin|oellhv8fksc)|p(?:cttwib15k25|dpbxj733bb1)|q(?:pxk1wfeh8v1|qddufal4d58)|r(?:27qvpjiaqj3|gnfh960lz2b|os97qkrwjf5)|spb7fplenrp4|uh1a7az90pt0|v(?:9u0bgi1uimx|bm0eveofcle)|wscoizcbxzhp|yu5hbtu8mng9|z(?:2jf7jlzjs58|gderxoe1a))\.cloudfront|2(?:3(?:guct4biwna6|nyyb6dc29z6|p9gffjvre9v)|5ruj6ht8bs1|6(?:dzd2k67we08|j9bp9bq4uhd|wy0pxd3qqpv)|7jt7xr4fq3e8|87x05ve9a63s|9r6igjpnoykg|anfhdgjxf8s1|b(?:2x1ywompm1b|65ihpmocv7w|gg7rjywcwsy)|cxkkxhecdzsq|d(?:2lbvq8xirbs|xgm96wvaa5j)|g(?:fi8ctn6kki7|pgaupalra1d|tlljtkeiyzd|z6iop9uxobu)|hap2bsh1k9lw|ipklohrie3lo|kmrmwhq7wkvs|m(?:ic0r0bo3i6z|q0uzafv8ytp)|nlytvx51ywh9|o(?:307dm5mqftz|allm7wrqvmi|h4tlt9mrke9|mcicc3a4zlg)|p(?:gy8h4i30on1|lxos94peuwp)|r(?:359adnh3sfn|y9vue95px0b)|so4705rl485y|t(?:gev5wuprbqq|nimpzlb191i)|ubicnllnnszy|v(?:4glj2m8yzg5|9ajh2eysdau|t6q0n0iy66w)|yhukq7vldf1u|z1smm3i01tnr)\.cloudfront|3(?:1807xkria1x4|2pxqbknuxsuy|3(?:f10u0pfpplc|im0067v833a|otidwg56k90)|4(?:ko97cxuv4p7|obr29voew8l)|6(?:aw3ue2ntmsq|lvucg9kzous|wtdrdo22bqa)|7kzqe5knnh6t|8(?:pxm3dmrdu6d|r21vtgndgb1)|9(?:6ihyrqc81w|xqloz8t5a6x)|bvcf24wln03d|cxv97fi8q177|dphmosjk9rot|ezl4ajpp2zy8|f(?:9mcik999dte|zrm6pcer44x)|h(?:1v5cflrhzi4|r5gm0wlxm5h)|i(?:rruagotonpp|wjrnl4m67rd)|l(?:3lkinz3f56t|vr7yuk4uaui|zezfa753mqu)|m41swuqq4sv5|nvrqlo8rj1kw|ojzyhbolvoi5|p(?:9ql8flgemg7|kae9owd2lcf)|q(?:2dpprdsteo|szud4qdthr8|xef4rp70elm)|s7ggfq1s6jlj|t(?:2wca0ou3lqz|9ip55bsuxrf|defw8pwfkbk)|vc1nm9xbncz5)\.cloudfront|5(?:nxst8fruw4z|pvnbpawsaav)\.cloudfront|6(?:bdy3eto8fyu|jkenny8w8yo)\.cloudfront|8(?:1mfvml8p5ml|qy7md4cj3gz|rk54i4mohrb)\.cloudfront|al9hkyfi0m0n\.cloudfront|c8na2hxrj29i\.cloudfront|dwht76d9jvfl\.cloudfront|ew9ckzjyt2gn\.cloudfront|f(?:dbz2tdq3k01\.cloudfront|o\.donemace)|i(?:s(?:play\.superbay|y2s34euyqm\.cloudfront)|zixdllzznrf\.cloudfront)|jlf5xdlz7m8m\.cloudfront|k(?:d(?:69bwkvrht1|wv3lcby5zi)|j2m377b0yzw)\.cloudfront|l(?:1d2m8ri9v3j|392qndlveq0|5v5atodo7gn|upv9uqtjlie)\.cloudfront|m(?:0acvguygm9h|8srf206hien)\.cloudfront|nn506yrbagrg\.cloudfront|oug1izaerwt3\.cloudfront|p(?:51h10v6ggpa|sq2uzakdgqz)\.cloudfront|q2tgxnc2knif\.cloudfront|s-aksb-a\.akamaihd|t\.sellpoint|ufue2m4sondk\.cloudfront|vf2u7vwmkr5w\.cloudfront|ws?\.cbsimg|x(?:5qvhwg92mjd|q(?:6c0tx3v6mm|d86uz345mg))\.cloudfront|y(?:cpc40hvg4ki|l3p6so5yozo)\.cloudfront|zxxxg6ij9u99\.cloudfront)|e(?:space-plus|wc\.scriptpage)|f(?:astcounter\.onlinehoster|reexxxvideoclip\.aebn)|g(?:e(?:o\.(?:kontagent|q5media)|ts\.faz)|zd\.donejs)|hop\.clickbank|i(?:-stats\.ieurop|nskin\.vo\.llnwd)|l(?:cs\.livedoor|iveperson|oglady\.publicbroadcasting|psnmedia)|m(?:a(?:ik\.ff-bt|rketing\.kalahari)|etrixlablw\.customers\.luna|int\.boingboing)|n(?:eocounter\.neoworx-blog-tools|ova\.dice)|o(?:as\.skyscanner|bserver\.ip-label|pen(?:\.delivery|x)|x\.furaffinity)|p(?:\.dsero|agevisit|roduction(?:-(?:eqbc|mcs)\.lvp\.llnw|\.mcs\.delve\.cust\.lldns)|ulse-analytics-beacon\.reutersmedia|x\.(?:owneriq|topspin))|r(?:ed\.bayimg|mbn|ou\.resyncload|pt\.anchorfree|vzr-a\.akamaihd)|s(?:ecure\.footprint|ftrack\.searchforce|quarespace\.evyy|t(?:atstracker\.celebrity-gossip|ream\.heavenmedia)|yndication1\.viraladnetwork)|t(?:a(?:p\.more-results|rget\.smi2)|i\.tradetracker|m(?:\.tradetracker|cs)|r(?:\.(?:advanc|interlak)e|k\.newtention)|s\.faz)|u(?:counter\.ucoz|im(?:\.tifbs|serv)|rchin-tracker\.bigpoint)|v(?:atrack\.hinet|i(?:sit\.mobot|tamineworldmedia))|w(?:\.homes\.yahoo|eb(?:\.longfintuna|pagescripts)|idgets\.comcontent)|x\.(?:bloggura|castane)t|z(?:eus\.qj|ynga2-a\.akamaihd))\.net$/,
	/^(?:(?:sponsor|.+[.-])?ad\d*(?:(?:vert|serv|media|log|rot)[\w-]*)?|pagead|track\w*|click|analytic|counter|metric|(?:\w*web)?stat|aff(?:il\w*)?)s?\d*\.|(?:banner|[^o]traffic)[\w-]*\.|\.doubleclick\.net$|(?:adooza|quantserve|google-analytics|webtrendslive)\.com$/
],	DOMAINS_LENGTH = DOMAINS.length;
